/* Seamless3d

Copyright (C) 2001-2014 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

#define NARATION 1

extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preNurbsLatheAvDemo(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::nurbsLatheAvDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::nurbsLatheAvDemo(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		
		new Section("Create a new seamless file"),

		//new ResizeSceneTreeWin(330, 643),
		new ClickButton(fileMenu),
		new Move_MenuItem("new     (Ctrl N)"),
		new Click,
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\create-new-file.wav"),
#endif
new Section("Add boxes"),
new ClickButton(setBirdsEyeViewOrientation),

new ClickButton(buildBoxForSelPart),

new AddCtrlPnt(0, 0),
new AddCtrlPnt(.3,-.14),
new DragViewRot(.932978,-.355102,-.058771,.317241),
new AddCtrlPnt(.278125,.590625),
new ClickButton(convertToPatch),

new IncFieldX("control_bands", 5),
new IncFieldX("control_staves"),
//new IncFieldX("control_staves", 2),
new IncFieldX("control_staves"),
//new IncFieldX("control_z_staves"),
//new IncFieldX("control_z_staves"),
new ToggleField("done"),

new Section("Extrude sleeves"),
new TugCP(125,-.296953,.598494),
new ClickButton(extrudePatch),

new IncFieldX("distance",11),
new ToggleField("done"),
new Section("Extrude neck"),
new TugCP(279,.001208,.641492),
new ClickButton(extrudePatch),

new DecFieldX("distance",5),
new ToggleField("done"),

new Section("Delete patch"),
new DragViewRot(-.93663,-.348804,.032546,.303368),
new TugCP(258,0,0),
new ClickButton(moreModellingMenu),
new Move_MenuItem("delete selected patches"),
new Click,

new Section("Hide grid"),
new ClickButton(openGridControl),
new ToggleField("show"),
new MoveToExitWindow(),
new Click(),

new Section("Rotate sleeves"),
new ClickButton(toggleBackfaceSelect),

new ClickButton(setFrontViewOrientation),

new RectVert(.25,.74375,.525,.545833),

new Rotate(0,.790625,.389584),
new TugCP(303,.308879,.545646),


new Section("Flatten body"),
new ClickButton(setBirdsEyeViewOrientation),

new TugCP(345,0,.07008),
new MouseZoom(3.797499),
new ClickButton(centerViewToControlPoint),

new RectVert(-.834375,.33125,.819792,.172917),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.117708,.328125,0)),
new TugCP(237,0,.065521),
new RectVert(.859375,-.884375,-.911459,-.738542),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.026042,-.73125,0)),
new TugCP(80,0,-.58528),
new Section("Round out neck"),
//new DragViewRot(.986374,.089039,-.138343,.592218),
//new TugCP(345,.009268,.146819),
//new TugCP(348,.001446,.071161),
//new ClickButton(setFrontViewOrientation),
//
//new TugCP(337,-.000001,-.384281),
//new TugCP(330,-.000001,-.32083),
//new DragViewRot(-.085566,-.993779,-.071283,1.466003),
//new TugCP(80,-.632968,-.32205),
//new DragViewRot(.694309,.036421,-.718755,.591917),
//new ClickButton(setFrontViewOrientation),
//
//new TugCP(332,.379749,.197795),
//new TugCP(339,.375582,.113512),
//new TugCP(345,-.000001,.206838),
//new TugCP(348,-.000001,.136787),
//new DragViewRot(.56251,-.739458,-.369844,1.012802),
//
//new Section("Round out neck2"),

new ClickButton(setFrontViewOrientation),

new TugCP(330,0,.195833),
new TugCP(345,0,.195833),
new TugCP(332,.371417,.201962),
new TugCP(348,0,.086549),
new TugCP(337,0,.090716),
new TugCP(339,.371417,.117679),
new DragViewRot(.910368,.41263,-.031093,1.10355),
new ClickButton(toggleBackfaceSelect),

new ClickButton(insertControlPoint),

new SelNurbsLine(332,333,.956224),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(361,362,.045057),
new ToggleField("done"),
new ClickButton(setBirdsEyeViewOrientation),

new ClickButton(toggleBackfaceSelect),

new RectVert(.14375,-.096875,.2375,-.173958),
new TugCP(411,.256338,-.080094),
new RectVert(.140625,-.34375,.259375,-.4375),
new TugCP(407,.294076,-.471612),
new ClickButton(toggleBackfaceSelect),

new DragViewRot(.408826,-.874641,.260507,1.572659),
new TugCP(273,.009961,-.060306),
new Section("Make arm holes rounder"),
new TugCP(351,.070358,-.13025),
new TugCP(364,.116652,-.171365),
new TugCP(285,-.29142,-.283305),
new TugCP(347,-.157741,-.326954),
new TugCP(360,-.103115,-.359736),
new DragViewRot(-.105086,-.682947,.722869,1.203773),
new ClickButton(insertControlPoint),

new SelNurbsLine(356,357,.889864),
new ToggleField("done"),
new DragViewRot(-.186358,-.897396,.39994,1.828775),
new MouseZoom(3.452272),
new MouseZoom(3.138429),
new ClickButton(insertControlPoint),

new SelNurbsLine(409,410,.004502),
new ToggleField("done"),
new ClickButton(setFrontViewOrientation),

new TugCP(449,.96106,-.342129),
new TugCP(466,1.156466,-.355276),
new TugCP(451,.930129,-.249656),
new TugCP(468,1.163036,-.258637),
new TugCP(453,.928193,-.112033),
new TugCP(470,1.136102,-.146015),
new TugCP(82,.615184,-.124938),
new TugCP(80,-.000001,-.137438),
new DragViewRot(-.237439,-.967926,-.082111,1.473242),
new TugCP(451,-.294308,-.057725),
new TugCP(468,-.269621,-.033098),
new DragViewRot(-.158886,-.97832,-.132833,2.099864),
new ClickButton(setBackViewOrientation),

new TugCP(447,-.944738,-.206767),
new TugCP(464,-1.127645,-.224082),
new TugCP(461,-.928193,-.078699),
new TugCP(478,-1.115268,-.096015),
new TugCP(323,-.627684,-.087438),
new TugCP(325,.000002,-.087438),
new DragViewRot(-.005595,.999308,-.036785,4.412667),
new TugCP(447,-.324605,-.260831),
new TugCP(464,-.36011,-.243783),
new DragViewRot(-.036428,.997736,-.056526,5.207623),
new DragViewRot(.393074,.87015,-.297208,5.171054),
new DragViewRot(.68136,.573453,-.454863,4.798978),
new TugCP(236,.165545,.713745),
new TugCP(222,.178471,.62384),
new TugCP(208,.203896,.479769),
new TugCP(194,.225156,.352363),
new TugCP(180,.246415,.199958),
new DragViewRot(.701905,.610905,-.366231,4.095215),
new TugCP(232,.00117,.834714),
new TugCP(218,-.094051,.843546),
new TugCP(204,-.239272,.844043),
new TugCP(190,-.380326,.832041),
new TugCP(176,-.513047,.836706),
new DragViewRot(.490938,.740775,.45851,2.486264),
new ClickButton(setFrontViewOrientation),

new Section("insert lines in front of neck"),

new DragViewRot(.998077,-.035027,-.051144,.935196),
new ClickButton(insertControlPoint),

new SelNurbsLine(501,502,.1),
new ToggleField("done"),
new ClickButton(toggleBackfaceSelect),

new ClickButton(setFrontViewOrientation),

new RectVert(-.165625,.2375,.203125,.016667),
new ClickButton(setBirdsEyeViewOrientation),

new UnRectVert(-.13125,.146875,.120833,-.084375),
new ClickButton(setFrontViewOrientation),

new TugCP(579,0,-.225031),
new DragViewRot(.408212,-.911735,.045854,.883823),
new ClickButton(toggleBackfaceSelect),

new TugCP(575,-.430895,-.156568),
new TugCP(556,-.456933,-.108584),
new DragViewRot(.798352,-.565859,-.206007,1.204066),
new TugCP(556,-.452114,-.115215),
new TugCP(575,-.4226,-.146856),
new TugCP(558,-.42668,-.250091),
new TugCP(577,-.414305,-.258991),
new TugCP(564,-.002514,-.356844),
new TugCP(583,-.019286,-.359995),
new DragViewRot(-.024043,-.89786,-.439624,3.505301),
new TugCP(583,-.169634,.295412),
new DragViewRot(-.02849,-.395991,-.917812,3.862912),
new TugCP(126,.257511,.397563),
new TugCP(128,.026513,.578416),
new DragViewRot(.515398,-.508803,-.689554,4.066576),
new TugCP(124,.149377,.46304),
new TugCP(126,.110232,.510621),
new DragViewRot(-.176206,-.244734,-.953445,4.340765),


new Section("Insert extra ring arround neck"),
//new ClickButton(setFrontViewOrientation),

//new ClickButton(toggleBackfaceSelect),

new ClickButton(insertControlPoint),

new SelNurbsLine(537,556,.523316),
new ToggleField("done"),
new DragViewRot(.191437,-.691853,-.696198,4.388929),
new TugCP(560,.363578,.329501),
new DragViewRot(.412655,-.589138,-.694718,4.66399),
new TugCP(562,.292864,.461847),
new DragViewRot(.289743,-.78338,-.549877,4.101881),
new DragViewRot(.769609,-.584529,-.256959,1.043552),
new TugCP(456,-.971499,.205254),
new TugCP(473,-1.125118,.280663),

new Section("Refine index finger"),

new ClickButton(setFrontViewOrientation),

new ClickButton(selectRing),

new SelNurbsLine(470,471,.338727),
new Scale1d(0,-1.128816,-.138029),

//new Scale1d(0,-1.166546,-.133862),
new ClickButton(insertControlPoint),

new SelNurbsLine(454,471,.842584),
new ToggleField("done"),
new ClickButton(selectRing),

new SelNurbsLine(505,506,.549096),

new Scale1d(1,-1.133318,.26463),
new ClickButton(setBirdsEyeViewOrientation),


new Scale1d(1,-1.133318,.180274),
new ClickButton(selectRing),

new SelNurbsLine(493,494,.105115),
new TugCP(494,-1.136071,-.089342),
new DragViewRot(.162086,.925029,-.343585,.407124),
new ClickButton(insertControlPoint),

new SelNurbsLine(471,488,.674052),
new ToggleField("done"),
new DragViewPos(-.018578,-.086395,.040571,.984375,-.909375),
new ClickButton(setFrontViewOrientation),


new Section("Extrude pinky"),
new ClickButton(selectRing),

new SelNurbsLine(15,16,.36691),

new Scale1d(1,-.058306,-.085539),
new ClickButton(selectRing),

new SelNurbsLine(4,5,.53383),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.05625,.005208,0)),
new TugCP(300,-.058306,-.083434),

new DragViewRot(-.972844,-.221926,.065747,.958896),
new ClickButton(insertControlPoint),

new SelNurbsLine(14,25,.468204),
new ToggleField("done"),
new ClickButton(setWormsEyeViewOrientation),

new TugCP(170,-.850489,.273391),
new TugCP(168,-.951246,.123162),
new TugCP(166,-.86897,-.032023),
new DragViewRot(.998798,-.011453,-.047666,.460663),
new DragViewPos(-.021431,-.291106,.142028,1.275,.984375),
new ClickButton(setFrontViewOrientation),

new TugCP(338,.796438,.654837),
new TugCP(324,.802096,.311227),
new TugCP(310,.803592,-.046205),
new TugCP(296,.787293,-.384294),
new DragViewRot(.746129,.650968,-.139758,.758268),


new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
//new AddCtrlPnt(.418654,.522792),