/* Seamless3d

Copyright (C) 2001-2014 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

#define NARATION 1

extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preYouTubeTut(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::youTubeTut;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::youTubeTut(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int r_shoulder = 9;
	int r_elbow = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;

	const int r_hip = 13;
	int r_knee = 14;
	const int l_hip = 15;
	int l_knee = 16;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		
		new Section("Create a new seamless file"),

		//new ResizeSceneTreeWin(330, 643),
		new ClickButton(fileMenu),
		new Move_MenuItem("new     (Ctrl N)"),
		new Click,
#if NARATION
//F:\\Vlogs\\animated-character\\naration\\	
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\create-new-file.wav"),
#endif
//new Section("Set birds-eye-view"),
//#if NARATION
//	new DemoSound("F:\\Vlogs\\animated-character\\naration\\birds-eye.wav"),
//#endif
//new ClickButton(setBirdsEyeViewOrientation),
//new Wait(6),
new Section("Add box"),
#if NARATION

	new DemoSound("F:\\Vlogs\\animated-character\\naration\\add-box.wav"),
#endif

new ClickButton(buildBoxForSelPart),


new Move(643,360),
new Wait(1),
new LeftButtonDown(),
new LeftButtonUp(),
new Wait(.5),
new Move(723 + 10, 375 + 10),
new Move(723 - 1, 375),
new Wait(1),
new LeftButtonDown(),
new LeftButtonUp(),
new Move(761, 146 - 40),
new Move(761, 146 - 5),
new LeftButtonDown(),
new LeftButtonUp(),

/*

new Move(640,361),
new Wait(2),
new LeftButtonDown(),
new Wait(3),
new LeftButtonUp(),
new Move(713 - 10 , 402 + 10),
new Move(713 + 10, 402 - 10),
new Move(713,402),
new Wait(1),
new LeftButtonDown(),
new Wait(4),
new LeftButtonUp(),

new Move(707,399),
new Wait(2),
new RightButtonDown(),
new Move(717,40),
new RightButtonUp(),
new Wait(3),
new Move(719,160 - 20, 1),
new Move(719,160 + 50),
new Move(719,160),
new Move(719,160 + 50),
new Move(719,160),

new Wait(1, .6666),
new LeftButtonDown(),
new LeftButtonUp(),

new Move(471,214),

new RightButtonDown(),
new Move(571,203),
new RightButtonUp(),
*/

new Section("Convert to patch"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\convert-to-patches.wav"),
	new Wait(10),
#endif
new ClickButton(convertToPatch),
new Wait(2),
new IncFieldX("control_bands",7),
new IncFieldX("control_bands"),
new ToggleField("done"),

new Section("change-grid"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\change-grid.wav"),
#endif
new ClickButton(setFrontViewOrientation),

new ClickButton(openGridControl),

new ToggleField("xyPlane"),
new Wait(3),
new MoveToExitWindow(),
new Click(),

new Section("zoom-out-using-wheel"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\zoom-out-using-wheel.wav"),
#endif


new VirtKeyDown(VK_MENU),
new Move(422,453),
new LeftButtonDown(),
new Move(436,361),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),


new Section("drag-view-down"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\drag-view-down.wav"),
	new Wait(4),
#endif

new Move(523,332),
new LeftButtonDown(),
new Move(526,646),
new LeftButtonUp(),
new Wait(2),
new Section("backface-ignore-off"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\backface-ignore-off.wav"),
	new Wait(14),
#endif
new ClickButton(toggleBackfaceSelect),
new Wait(7.5),


new Section("Rectangle select"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\rectangle-select.wav"),
	new Wait(4),
#endif

new VirtKeyDown(VK_SHIFT),
new Move(550,403, .66666),
new LeftButtonDown(),
new Move(728,684),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),


new Wait(3.5),


new Section("Lever tool"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\lever-tool.wav"),
#endif

new Move(644,552),

new Wait(2),

new Move(643,399),
new Wait(.1),
new Move(646,371),
new Wait(.1),
new Move(645,351),
new Wait(.1),
new Move(620,370),
new Wait(.1),
new Move(621,396),
new Wait(.1),

new Move(642,398, .5), //translate up
new LeftButtonDown(),
new Move(643,183),
new LeftButtonUp(),

new Move(644,155),
new LeftButtonDown(), //rotate
new Move(605,158),
new Move(641 + 3,151),
new LeftButtonUp(),

new Move(644,127), //squash and stretch
new LeftButtonDown(),
new Move(644,209),
new Move(644,37),
new LeftButtonUp(),


new Move(621,61), //rotate in neutral
new LeftButtonDown(),
new Move(539,61),
//new Move(536, 69),
new Move(618 + 3, 64 - 8),
new LeftButtonUp(),

new Move(620,82), //scale
new LeftButtonDown(),
new Move(617,145),
new Move(616,84),
new LeftButtonUp(),


new Section("squash neck"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\squash-neck.wav"),
#endif

new Move(549,242, .3),
new VirtKeyDown(VK_SHIFT),
new LeftButtonDown(),
new Move(768,316),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(853,277),
new LeftButtonDown(),
new Move(726,266),
new LeftButtonUp(),
new Move(647,67),
new LeftButtonDown(),
new Move(630,143),
new LeftButtonUp(),
new Move(640,194),
new LeftButtonDown(),
new Move(636,163),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(528,297),
new LeftButtonDown(),
new Move(777,541),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(645,269),
new LeftButtonDown(),
new Move(633,203),
new LeftButtonUp(),
new Wait(1),
	
new Section("Extrude arms"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\extrude-arms.wav"),
#endif
new Wait(1),
new Move(582,270, .66666),
new Wait(9),
new VirtKeyDown(VK_SHIFT),
new Move(537,265),
new LeftButtonDown(),
new Move(539,266),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(582,271, .5),
new LeftButtonDown(),
new LeftButtonUp(),
new ClickButton(extrudePatch),



new IncFieldX("distance",57 + 41),
new IncFieldX("insertions"),
new IncFieldX("insertions"),
new ToggleField("spiderWebCenter"),
new ToggleField("done"),


new Section("Extrude legs"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\extrude-legs.wav"),
#endif
new Wait(1),
new Move(582,430, .4),
new LeftButtonDown(),
new Move(582,430),
new LeftButtonUp(),
new ClickButton(extrudePatch),

new IncFieldX("distance",87 + 26),
new IncFieldX("insertions"),
new IncFieldX("insertions"),
new ToggleField("spiderWebCenter"),
new ToggleField("done"),


new Section("view-in-different-orientations"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\view-in-different-orientations.wav"),
#endif

new Move(220,179, .66666),

new RightButtonDown(),
new Move(1116,542, 1),
new RightButtonUp(),

new Move(1078,114, .66666),

new RightButtonDown(),
new Move(225,434, 1),
new RightButtonUp(),

new Move(562,616, .66666),

new RightButtonDown(),
new Move(1213,60, 1),
new RightButtonUp(),

new Section("Rotate legs"),
new ClickButton(setFrontViewOrientation),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\rotate-legs.wav"),
#endif
new Wait(6),
new Move(687,429, .5),
new VirtKeyDown(VK_SHIFT),
new LeftButtonDown(),
new Move(987,636),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(822,528),
new LeftButtonDown(),
new Move(676,424),
new LeftButtonUp(),
new Move(856,425),
new LeftButtonDown(),
new Move(832,647),
new LeftButtonUp(),

new Wait(1),



new Section("Rotate arms"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\rotate-arms.wav"),
#endif

new Move(719,206, .5),
new VirtKeyDown(VK_SHIFT),
new Move(710,203),
new LeftButtonDown(),
new Move(847,289),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new ClickButton(toggleAccumulateSelect),

new Move(757,102),
new VirtKeyDown(VK_SHIFT),
new Move(767,106),
new LeftButtonDown(),
new Move(950,259),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(812,195),
new LeftButtonDown(),
new Move(702,265),
new LeftButtonUp(),
new Move(884,265),
new LeftButtonDown(),
new Move(866,363),
new LeftButtonUp(),
new Wait(3),
new Section("drag-red-point"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\drag-red-point.wav"),
#endif

new Move(740,287, .5),
new LeftButtonDown(),
new Move(778,354),
new LeftButtonUp(),
new Move(779,356),
new LeftButtonDown(),
new Move(833,237),
new LeftButtonUp(),
new ClickButton(setFrontViewOrientation),

new Move(794,57),
new LeftButtonDown(),
new Move(780,122),
new LeftButtonUp(),
new Move(950,277),
new LeftButtonDown(),
new Move(829,289),
new LeftButtonUp(),

new Wait(1),

new Move(762,626, .5),
new LeftButtonDown(),
new Move(773,518),
new LeftButtonUp(),
new VirtKeyDown(VK_MENU),
new Move(790,305),
new LeftButtonDown(),
new Move(779,436),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),


new Section("squash-inner-lines-in"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\squash-inner-lines-in.wav"),
#endif

new Wait(1),

new Move(630,370, .66666),
new VirtKeyDown(VK_SHIFT),
new Move(630,370),
new LeftButtonDown(),
new Move(684,687),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(871,149),
new Move(991,102),
new Wait(2),

new ClickButton(toggleAccumulateSelect),
new Wait(1),

new Move(652,385, .5),
new VirtKeyDown(VK_SHIFT),
new Move(629,374),
new LeftButtonDown(),
new Move(685,688),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(864,534),
new LeftButtonDown(),
new Move(713,531),
new LeftButtonUp(),

new VirtKeyDown(VK_MENU),
new Move(824,505, .4),
new LeftButtonDown(),
new Move(810,389),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new Move(803,334),
new LeftButtonDown(),
new Move(806,385),
new LeftButtonUp(),

///////
new Section("drag-model-up"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\drag-model-up.wav"),
#endif

new VirtKeyDown(VK_SHIFT),
new Move(339,54, .5),
new LeftButtonDown(),
new Move(975,688),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),

new Wait(1),

new Section("avoid-straying-left-or-right"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\avoid-straying-left-or-right.wav"),
#endif

new Move(595,332, .5),
new LeftButtonDown(),
new Move(616,290),
new LeftButtonUp(),

new Move(614,292),
new LeftButtonDown(),
new Move(592,288),
new LeftButtonUp(),
new Move(657,116),
new LeftButtonDown(),
new Move(657,160),
new Move(656,161),
new Move(656,118),
new LeftButtonUp(),

new Move(657,205),
new LeftButtonDown(),
new Move(657,205 - 40),
new Move(657,205),
new LeftButtonUp(),

new Section("drag-pivot-point-to-floor"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\drag-pivot-point-to-floor.wav"),
#endif



new Move(787,341),
new LeftButtonDown(),
new Move(782,386),
new LeftButtonUp(),
new Move(652,317),
new LeftButtonDown(),
new Move(652,667),
new LeftButtonUp(),
new Move(651,460),
new Wait(1),
new LeftButtonDown(),
new Move(652,509),
new LeftButtonUp(),
new Move(652,509),
new LeftButtonDown(),
new Move(650,460),
new LeftButtonUp(),
new Wait(5),
new Move(860,668),
new LeftButtonDown(),
new Move(802,674),
new LeftButtonUp(),
new Move(801,667),
new LeftButtonDown(),
new Move(856,664),
new LeftButtonUp(),
new Wait(2),

new Section("want-rounder-head"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\want-rounder-head.wav"),
#endif
new VirtKeyDown(VK_SHIFT),
new Move(545,56, .5),
new LeftButtonDown(),
new Move(734,128),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(717,53),
new LeftButtonDown(),
new Move(720,195),
new LeftButtonUp(),
new Move(653,96),


new LeftButtonDown(),

new Move(657,81),
new LeftButtonUp(),


//new Wait(100), BUG
new Section("should-be-more-evenly-spaced"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\should-be-more-evenly-spaced.wav"),
#endif

new VirtKeyDown(VK_MENU),
new Move(761,112),
new LeftButtonDown(),
new Move(911,699),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),


new VirtKeyDown(VK_CONTROL),
new Move(817,327),
new LeftButtonDown(),
new Move(817,327),
new LeftButtonUp(),
new VirtKeyUp(VK_CONTROL),
new Wait(5),
new Section("try-different-view-orientation"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\try-different-view-orientation.wav"),
#endif
new ClickButton(setLeftViewOrientation),

new Move(625,318),
new VirtKeyDown(VK_SHIFT),
new Move(626,317),
new LeftButtonDown(),
new Move(657,343),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(641,179),
new LeftButtonDown(),
new Move(647,162),
new LeftButtonUp(),
new Move(552,324),
new VirtKeyDown(VK_SHIFT),
new Move(539,324),
new LeftButtonDown(),
new Move(749,368),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(641,180),
new LeftButtonDown(),
new Move(638,206),
new LeftButtonUp(),

new Section("edit-side-view 3"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\improve-neck-and-head-side-on.wav"),
#endif

new Move(530,242),
new VirtKeyDown(VK_SHIFT),
new LeftButtonDown(),
new Move(750,313),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(844,286),
new LeftButtonDown(),
new Move(768,296),
new LeftButtonUp(),
new Move(499,35),
new VirtKeyDown(VK_SHIFT),
new Move(501,32),
new LeftButtonDown(),
new Move(775,243),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),

new Section("stretch-head-and-translate-forward"),
new Move(843,141),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\stretch-head-and-translate-forward.wav"),
#endif

new LeftButtonDown(),
new Move(954,151),
new LeftButtonUp(),
new Move(905,142),
new LeftButtonDown(),
new Move(883, 143),
new LeftButtonUp(),
new VirtKeyDown(VK_MENU),
new Move(904,579),
new LeftButtonDown(),
new Move(880,341),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new Section("dragging-individual-points"),

new Move(829,560),
new LeftButtonDown(),
new Move(847,462),
new LeftButtonUp(),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\dragging-individual-points.wav"),
#endif

new Move(710,369),
new LeftButtonDown(),
new Move(700,370),
new LeftButtonUp(),
new Move(710,426),
new LeftButtonDown(),
new Move(719,429),
new LeftButtonUp(),
new Move(601,270),
new LeftButtonDown(),
new Move(610,266),
new LeftButtonUp(),



new Move(875,602),
new LeftButtonDown(),
new Move(835,318),
new LeftButtonUp(),


new Section("stretch-legs-to-round"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\stretch-legs-to-round.wav"),
#endif
new VirtKeyDown(VK_SHIFT),
new Move(511,263),
new LeftButtonDown(),
new Move(837,661),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),

new Move(830,466),
new LeftButtonDown(),

new Move(905,466),
new LeftButtonUp(),

new Move(738,396),
new RightButtonDown(),
new Move(1087,466),
new RightButtonUp(),
new Wait(1.2),
new ClickButton(setFrontViewOrientation),

new Section("flatten-rings"),

new VirtKeyDown(VK_SHIFT),
new Move(542,261),
new LeftButtonDown(),
new Move(786,345),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\flatten-rings.wav"),
#endif

new Move(665,85, 1),
new LeftButtonDown(),
new Move(664, 255 + 10),
new LeftButtonUp(),
new Move(665,312 + 10),
new LeftButtonDown(),
new Move(667,276 + 10),
new LeftButtonUp(),
new Move(523,177, .4),
new VirtKeyDown(VK_SHIFT),
new Move(524,173),
new LeftButtonDown(),
new Move(803,310),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(667,94),
new LeftButtonDown(),
new Move(663,57),
new LeftButtonUp(),

new VirtKeyDown(VK_SHIFT),
new Move(509,392),
new LeftButtonDown(),
new Move(807,522),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(660,260),
new LeftButtonDown(),
new Move(663,426 + 14),
new LeftButtonUp(),

new Move(663,479 + 14),
new LeftButtonDown(),
new Move(662,409 + 14),
new LeftButtonUp(),

new VirtKeyDown(VK_SHIFT),
new Move(520,583),
new LeftButtonDown(),
new Move(789,682),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(666,435),
new LeftButtonDown(),
new Move(658,607 + 10),
new LeftButtonUp(),

new Section("keep-points-neat"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\keep-points-neat.wav"),
#endif
new VirtKeyDown(VK_MENU),
new Move(946,662),
new LeftButtonDown(),
new Move(950,427),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),

new Move(971,232),
new LeftButtonDown(),
new Move(960,344),
new LeftButtonUp(),


new VirtKeyDown(VK_SHIFT),
new Move(893,173),
new LeftButtonDown(),
new Move(944,257),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),


new Move(1114,212),
new LeftButtonDown(),
new Move(947 - 14,212),
new LeftButtonUp(),



new VirtKeyDown(VK_SHIFT),
new Move(788,178),
new LeftButtonDown(),
new Move(839,254),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),

new Move(1012,212),
new LeftButtonDown(),
new Move(845 - 14,213),
new LeftButtonUp(),

new Move(796 - 14,211),
new LeftButtonDown(),
new Move(785 - 14,210),
new LeftButtonUp(),


new VirtKeyDown(VK_SHIFT),
new Move(694,184),
new LeftButtonDown(),
new Move(730,240),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),

new Move(910,212),
new LeftButtonDown(),
new Move(744 - 15,214),
new LeftButtonUp(),


new Section("make-arms-thinner"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\make-arms-thinner.wav"),
#endif

new VirtKeyDown(VK_SHIFT),
new Move(696,178),
new LeftButtonDown(),
new Move(926,239),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(884,48),
new LeftButtonDown(),
new Move(885,83),
new LeftButtonUp(),
new Move(803,40),
new LeftButtonDown(),
new Move(805,72),
new LeftButtonUp(),

new Move(885,83),
new LeftButtonDown(),
new Move(884,48),
new LeftButtonUp(),

new Section("insert-rings"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\insert-rings.wav"),
#endif


new ClickButton(insertControlPoint),

new Move(605,497),
new Move(582,431, 2.3),
new Move(582,482),


new Move(582,472),
new Wait(1),
new LeftButtonDown(),
new Wait(1),
new Move(582,472, .66666),
new LeftButtonUp(),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new Section("extra-rings-for-limb-animation"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\extra-rings-for-limb-animation.wav"),
#endif


new Move(507,213),
new LeftButtonDown(),
new Move(507,213),
new LeftButtonUp(),
new ToggleField("done"),


new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),

new Move(357,60),
new LeftButtonDown(),
new Move(590,237),
new LeftButtonUp(),

new Move(924,552),
new LeftButtonDown(),
new Move(499,437),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),


//new Section("squash-ring-points"),
//#if NARATION
//	new DemoSound("F:\\Vlogs\\animated-character\\naration\\squash-ring-points.wav"),
//#endif


new Section("add-skeleton"),
new Wait(0,.5),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\add-skeleton.wav"),
#endif
new ClickButton(setFrontViewOrientation),

new ClickButton(setXRayEditMode),
new Wait(4),
new Move(644,663),
new Wait(6),
new LeftButtonDown(),
new Move(645,353),
new LeftButtonUp(),
new Wait(3),

new Section("add-more-bones"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\add-more-bones.wav"),
#endif
new ClickButton(setAddBoneMode),

new Move(644,328, .58),
new LeftButtonDown(),
new Move(644,328),
new LeftButtonUp(),
new Move(644,286),
new LeftButtonDown(),
new Move(644,286),
new LeftButtonUp(),
new Move(644,243),
new LeftButtonDown(),
new Move(644,243),
new LeftButtonUp(),
new Move(645,190),
new LeftButtonDown(),
new Move(645,190),
new LeftButtonUp(),
new Move(645,162),
new LeftButtonDown(),
new Move(645,162),
new LeftButtonUp(),

new VirtKeyDown(VK_CONTROL),
new Move(644,243),
new LeftButtonDown(),
new Move(644,243),
new LeftButtonUp(),
new VirtKeyUp(VK_CONTROL),
new Move(583,212),
new LeftButtonDown(),
new Move(583,212),
new LeftButtonUp(),
new Move(492,212),
new LeftButtonDown(),
new Move(492,212),
new LeftButtonUp(),

new Section("delete-bone"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\delete-bone.wav"),
#endif
//new ClickButton(setAddBoneMode),

new Move(614,353, .6666),
new LeftButtonDown(),
new Move(614,353),
new LeftButtonUp(),
new Wait(2),
new ClickButton(deleteNode),
new Wait(2),

new Move(645,351, .5),
new LeftButtonDown(),
new LeftButtonUp(),
new Move(614,352),
new LeftButtonDown(),
new Move(614,352),
new LeftButtonUp(),
new Move(614,498),
new LeftButtonDown(),
new Move(614,498),
new LeftButtonUp(),



new Section("drag-descendant-bones"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\drag-descendant-bones.wav"),
#endif
//new ClickButton(setAddBoneMode),

new Move(614,353,.7),
new LeftButtonDown(),
new Move(512,353),
new LeftButtonUp(),
new Move(512,353),
new LeftButtonDown(),
new Move(614,353 - 1),
new LeftButtonUp(),
new ClickButton(toggleDragWithDescendantsMode),

new Move(614,353),
new LeftButtonDown(),
new Move(498,363),
new LeftButtonUp(),
new Move(498,363),
new LeftButtonDown(),
new Move(614,353 - 1),
new LeftButtonUp(),

new ToggleField("done"),
new Wait(2),

new Section("name-bones"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\name-bones.wav"),
#endif

	new ClickButton(openSceneTree),
new MoveToNodeAsChild(pelvis),
new DoubleClick(),
new TypeString("pelvis"),
new SelectNode(4),
new TypeString("tummy0"),
new SelectNode(5),
new TypeString("tummy1"),
new SelectNode(6),
new TypeString("thorax"),
new SelectNode(7),
new TypeString("neck0"),
new SelectNode(8),
new TypeString("head"),
new SelectNode(9),
new TypeString("r_shoulder"),
new SelectNode(10),
new TypeString("r_elbow"),
new SelectNode(13),
new TypeString("r_hip"),
new SelectNode(14),
new TypeString("r_knee"),
new TypeVirtKey(VK_RETURN),



new Section("paint-ownership-mode"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\paint-ownership-mode.wav"),
#endif
new Wait(3),
new ClickButton(setPaintColorCodedControlPoints),
new Wait(2),
new Move(646,352, .5),
new LeftButtonDown(),
new Move(646,352),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(626,337),
new LeftButtonDown(),
new Move(663,371),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(645,328),
new LeftButtonDown(),
new Move(645,328),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(561,312),
new LeftButtonDown(),
new Move(726,339),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(643,287, .1),
new LeftButtonDown(),
new Move(643,287),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(557,271),
new LeftButtonDown(),
new Move(720,298),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(644,244),
new LeftButtonDown(),
new Move(644,244),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(572,237),
new LeftButtonDown(),
new Move(717,258),
new LeftButtonUp(),
new Move(612,206),
new LeftButtonDown(),
new Move(664,227),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(644,190),
new LeftButtonDown(),
new Move(644,190),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(613,180),
new LeftButtonDown(),
new Move(678,199),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(644,161),
new LeftButtonDown(),
new Move(644,161),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(546,43),
new LeftButtonDown(),
new Move(733,171),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(582,213),
new LeftButtonDown(),
new Move(583,213),
new LeftButtonUp(),

new VirtKeyDown(VK_SHIFT),
new Move(498,183),
new LeftButtonDown(),
new Move(593,235),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new Move(492,212),
new LeftButtonDown(),
new Move(492,212),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new Move(367,178),
new LeftButtonDown(),
new Move(499,243),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),

new Move(613,351),
new LeftButtonDown(),
new Move(613,351),
new LeftButtonUp(),


new VirtKeyDown(VK_MENU),
new Move(527,277),
new LeftButtonDown(),
new Move(479,654),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),

new VirtKeyDown(VK_SHIFT),
new Move(529,382),
new LeftButtonDown(),
new Move(648,568),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),


new VirtKeyDown(VK_MENU),
new Move(496,512),
new LeftButtonDown(),
new Move(495,188),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),

new Move(613,506),
new LeftButtonDown(),
new Move(613,506),
new LeftButtonUp(),

new VirtKeyDown(VK_SHIFT),
new Move(562,496),
new LeftButtonDown(),
new Move(644,689),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),

new MoveToExitSceneTree(),
new Click(),
new MoveToExitWindow(),
new Click(),
new MoveToExitWindow(),
new Click(),

new Section("animation-mode"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\animation-mode.wav"),
#endif
	new Wait(1, .6666),
new ClickButton(setAnimationMode),
new Wait(2),
new DecFieldX("period"),
new Wait(2, 1),
new DragAnimSlider(.5),
new Move(579,201, .6666),
new LeftButtonDown(),
new Move(579,201),
new LeftButtonUp(),
new Move(760,202),
new LeftButtonDown(),
new Move(726,409),
new LeftButtonUp(),
new ClickButton(playAnim),



	new Wait(1.5),

new Section("wave-down"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\wave-down.wav"),
#endif
new Move(759,201),
new LeftButtonDown(),
new Move(596,40),
new LeftButtonUp(),
new Wait(5),

new Section("copy-paste-pose"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\copy-paste-pose.wav"),
#endif
new Wait(2, .6666),
new ToggleField("copy"),
new Wait(2, .5),
new DragAnimSlider(0),
new Wait(.3),
new ToggleField("paste"),
new Wait(.3),
new ToggleField("ok"),
new Wait(.3),
new ToggleField("loop"),
	new ClickButton(playAnim),
	new Wait(3),
new ToggleField("pause"),


new Section("drag-pelvis-pivot-point"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\drag-pelvis-pivot-point.wav"),
#endif
new Wait(0, .4),
new DragAnimSlider(.5),
new Move(710,201),
new LeftButtonDown(),
new Move(710,201),
new LeftButtonUp(),
new Move(891,203),
new LeftButtonDown(),
new Move(820,41),
new LeftButtonUp(),


new VirtKeyDown(VK_MENU),
new Move(862,584),
new LeftButtonDown(),
new Move(862,469 - 40),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),


new Move(831,426),
new LeftButtonDown(),
new Move(831,481),
new LeftButtonUp(),
new Move(644, 412 - 3),
new LeftButtonDown(),
new Move(644, 286 - 3),
new LeftButtonUp(),


new Section("legs-rotate-out"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\legs-rotate-out.wav"),
#endif

new Move(671,283, .4),
new LeftButtonDown(),
new Move(671,281),
new LeftButtonUp(),
new Move(851,281),
new LeftButtonDown(),
new Move(832,181),
new LeftButtonUp(),
new Move(619,283),
new LeftButtonDown(),
new Move(620,284),
new LeftButtonUp(),
new Move(800,280),
new LeftButtonDown(),
new Move(768,370),
new LeftButtonUp(),


new DragAnimSlider(0),

new Section("left-arm-down"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\left-arm-down.wav"),
#endif


new Move(694,297, .4),
new LeftButtonDown(),
new Move(694,297),
new LeftButtonUp(),
new Move(873,295),
new LeftButtonDown(),
new Move(711,476),
new LeftButtonUp(),


new ToggleField("copy"),
new DragAnimSlider(1),
new ToggleField("paste"),
new ToggleField("ok"),


	new ClickButton(playAnim),
	new Wait(3),
new ToggleField("pause"),

new Section("pose-from-side-view"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\pose-from-side-view.wav"),
#endif
new Wait(0,.6666),


new DragAnimSlider(0),

new VirtKeyDown(VK_CONTROL),
new Move(643,408),
new LeftButtonDown(),
new Move(643,408),
new LeftButtonUp(),
new VirtKeyUp(VK_CONTROL),
new ClickButton(setLeftViewOrientation),

new Section("lean-forward"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\lean-forward.wav"),
#endif

new Move(809,408, .4),
new LeftButtonDown(),
new Move(808,374),
new LeftButtonUp(),

new Move(732,289),

new RightButtonDown(),
new Move(1169,522),
new RightButtonUp(),
new Move(603,393),
new LeftButtonDown(),
new Move(603,393),
new LeftButtonUp(),
new ClickButton(setLeftViewOrientation),

new Move(808,407),
new LeftButtonDown(),
new Move(731,526),
new LeftButtonUp(),
new Move(556,500),
new LeftButtonDown(),
new Move(556,500),
new LeftButtonUp(),
new Move(732,500),
new LeftButtonDown(),
new Move(604,272),
new LeftButtonUp(),

//left leg
new Move(630,408),
new LeftButtonDown(),
new Move(630,408),
new LeftButtonUp(),
new Move(812,406),
new LeftButtonDown(),
new Move(701,488),
new LeftButtonUp(),
new Move(552,502),
new LeftButtonDown(),
new Move(550,503),
new LeftButtonUp(),
new Move(737,500),
new LeftButtonDown(),
new Move(613,242),
new LeftButtonUp(),

new Section("drag-pelvis-down.wav"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\drag-pelvis-down.wav"),
#endif
new ClickButton(setFrontViewOrientation),

new Move(645,406),
new LeftButtonDown(),
new Move(645,462, .8),
new LeftButtonUp(),
new Wait(1.5),

new Section("pose-arms-side-view"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\pose-arms-side-view.wav"),
#endif
new Move(593,352, .4),
new LeftButtonDown(),
new Move(593,352),
new LeftButtonUp(),
new ClickButton(setLeftViewOrientation),

new Move(790,353),
new LeftButtonDown(),
new Move(773,256),
new LeftButtonUp(),
new Move(656,407),
new LeftButtonDown(),
new Move(656,407),
new LeftButtonUp(),
new Move(834,408),
new LeftButtonDown(),
new Move(730,514),
new LeftButtonUp(),

new Move(609,353),
new LeftButtonDown(),
new LeftButtonUp(),

new Move(790,353),
new LeftButtonDown(),
new Move(773,256),
new LeftButtonUp(),
new Move(656,407),
new LeftButtonDown(),
new Move(656,407),
new LeftButtonUp(),
new Move(834,408),
new LeftButtonDown(),
new Move(730,514),
new LeftButtonUp(),

new Section("copy-paste-pose2"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\copy-paste-pose2.wav"),
#endif
new Wait(0, .6),
new ToggleField("copy"),
new DragAnimSlider(1),
new ToggleField("paste"),
new ToggleField("ok"),
new DragAnimSlider(.5),

new Section("straighten-limbs"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\straighten-limbs.wav"),
#endif
new Wait(0, .4),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(399,296),
new LeftButtonDown(),
new Move(882,358),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(726,393),
new LeftButtonDown(),
new Move(726,393),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(988,295),
new LeftButtonDown(),
new Move(587,453),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(854,411),
new LeftButtonDown(),
new Move(711,592),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(394,314),
new LeftButtonDown(),
new Move(1069,446),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(510,144),
new LeftButtonDown(),
new Move(796,389),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(602,364),
new LeftButtonDown(),
new Move(603,364),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(665,197),
new LeftButtonDown(),
new Move(593,278),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(770,383),
new LeftButtonDown(),
new Move(629,207),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(884,454),
new LeftButtonDown(),
new Move(395,140),
new LeftButtonUp(),
new Move(628,488),
new LeftButtonDown(),
new Move(685,359),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),





new Move(778,138),
new LeftButtonDown(),
new Move(777,139),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(1053,223),
new LeftButtonDown(),
new Move(548,399),
new LeftButtonUp(),
new Move(804,469),
new LeftButtonDown(),
new Move(545,130),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(682,137),
new LeftButtonDown(),
new Move(602,278),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(628,165),
new LeftButtonDown(),
new Move(1155,136),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(415,216),
new LeftButtonDown(),
new Move(415,215),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(337,318),
new LeftButtonDown(),
new Move(1067,399),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyDown(VK_MENU),
new Move(706,539),
new LeftButtonDown(),
new Move(1011,165),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(994,163),
new LeftButtonDown(),
new Move(913,34),
new LeftButtonUp(),
new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(1079,200),
new LeftButtonDown(),
new Move(369,428),
new LeftButtonUp(),
new Move(642,542),
new LeftButtonDown(),
new Move(567,191),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),


new Section("arch-spine-back"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\arch-spine-back.wav"),
#endif
new Wait(0, .4),
new ClickButton(setLeftViewOrientation),


new Move(625,262),
new LeftButtonDown(),
new Move(625,262),
new LeftButtonUp(),
new Move(805,264),
new LeftButtonDown(),
new Move(806,277),
new LeftButtonUp(),
new Move(618,230),
new LeftButtonDown(),
new Move(618,230),
new LeftButtonUp(),
new Move(801,228),
new LeftButtonDown(),
new Move(800,237),
new LeftButtonUp(),
new Move(617,195),
new LeftButtonDown(),
new Move(617,195),
new LeftButtonUp(),
new Move(798,193),
new LeftButtonDown(),
new Move(798,205),
new LeftButtonUp(),

new Section("change-view-to-select-bone"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\change-view-to-select-bone.wav"),
#endif
new Wait(0, .4),

new VirtKeyDown(VK_SHIFT),
new VirtKeyDown(VK_MENU),
new Move(825,141),
new LeftButtonDown(),
new Move(1007,180),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),
new VirtKeyUp(VK_SHIFT),
new Move(623,153),
new LeftButtonDown(),
new Move(625,153),
new LeftButtonUp(),
new ClickButton(setLeftViewOrientation),

new Move(799,150),
new LeftButtonDown(),
new Move(800,184),
new LeftButtonUp(),
new Move(623,129),
new LeftButtonDown(),
new Move(623,129),
new LeftButtonUp(),
new Move(805,128),
new LeftButtonDown(),
new Move(806,145),
new LeftButtonUp(),
new ClickButton(setFrontViewOrientation),
new ClickButton(playAnim),


new Section("looks-better"),
new Wait(.5,.4),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\looks-better.wav"),
#endif

new DragViewRot(.743171,-.474451,-.471798,.812823, -.811111,-.794444),

new ClickButton(openGridControl),
new ToggleField("xzPlane"),
new MoveToExitWindow(),
new Click(),
new Wait(1.5),

new DragViewRot(.34373,-.935694,.079539,1.688576, -.811111,-.794444),
new Wait(2),
//new DragViewRot(.730552,-.538886,-.419401,1.169646, -.811111,-.794444),
//new Wait(2),

new Section("slow-down-peak"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\slow-down-peak.wav"),
#endif
	new Wait(0, .666),

new ToggleField("pause"),
new DragAnimSlider(.4),
new ClickButton(setFrontViewOrientation),

new Move(643,320),
new LeftButtonDown(),
new Move(642,294),
new LeftButtonUp(),
new DragAnimSlider(.6),
new Move(642,319),
new LeftButtonDown(),
new Move(643,296),
new LeftButtonUp(),
new ClickButton(playAnim),

new VirtKeyDown(VK_MENU),
new VirtKeyDown(VK_SHIFT),
new Move(1053,209),
new LeftButtonDown(),
new Move(664,251),
new LeftButtonUp(),
new VirtKeyUp(VK_SHIFT),
new VirtKeyUp(VK_MENU),
new Move(664 - 200,251 - 200),
new Wait(1.5),
new Section("there"),
#if NARATION
	new DemoSound("F:\\Vlogs\\animated-character\\naration\\there.wav"),
#endif
new Wait(2),

new ClickButton(toggleXRayMode),
new ClickButton(togglePerspective),

new VirtKeyDown(VK_MENU),
new Move(995,201),
new LeftButtonDown(),
new Move(977,269),
new LeftButtonUp(),
new VirtKeyUp(VK_MENU),


new Wait(5),

new VirtKeyDown(VK_MENU),
new VirtKeyDown(VK_SHIFT),
new Move(386,154),
new LeftButtonDown(),
new Move(982,173),
new LeftButtonUp(),

new Wait(2),


new Move(1046,82),
new LeftButtonDown(),
new Move(841,434),
new LeftButtonUp(),

new Wait(2),

new Move(877,555),
new LeftButtonDown(),
new Move(625,114),
new LeftButtonUp(),



new VirtKeyUp(VK_SHIFT),
new VirtKeyUp(VK_MENU),

new Move(625 + 200, 114),
//new DragViewRot(-.412569,.878756,-.239949,.895045, .394444,.658333),
//new Wait(1.5),
//new DragViewRot(-.437958,.863596,-.249787,.907806, .394444,.658333),
//new Wait(1.5),
//new DragViewRot(.469848,.532749,.703862,1.740346, .394444,.658333),
//new Wait(1.5),
//new DragViewRot(.842372,-.52,-.141459,.800308, .394444,.658333),
//new Wait(1.5),
//new DragViewRot(.838397,-.527233,-.13826,.798718, .394444,.658333),
//new Wait(1.5),
//try some perspective
new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
//new AddCtrlPnt(.418654,.522792),