/* Seamless3d

Copyright (C) 2001-2014 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

#define NARATION 1

extern const char* menu_open;

extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preYouTubeTut(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::youTubeTut;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::youTubeTut(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		new Section("lead-up-to-xmas.wav"),
		new  DemoMove(-1,.869444),
#if NARATION
	new DemoSound("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\naration\\lead-up-to-xmas.wav"),
#endif
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\paper.smls"),
		new Wait(13),

		new Section("traced-sketch"),
#if NARATION
	new DemoSound("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\naration\\traced-sketch.wav"),
#endif
		new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141227-Sketched-head.smls"),
		new Wait(8),

		new Section("remove-png.wav"),
#if NARATION
	new DemoSound("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\naration\\remove-png.wav"),
#endif
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\removed-png-sketch.smls"),
		new Wait(5),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\removed-png-sketch-modeling-mode.smls"),
//new ClickButton(setModellingMode),

new MouseZoom(8.00923,-1,.869444),
new RectVert(.018056,.338889,.753473,-.196528),
new Rotate(1,.492208,.59323),
new Scale1d(0,.895844,.039878),
new TugCP(221,.744199,.186394),



new RectVert(.415278,.65,.888196,.366667),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.449843,.517261,0)),
new Rotate(0,.90401,.438094),
//new TugCP(162,.466123,.523406),
//new RectVert(.056944,.488889,.219444,.332639),
//new TugCP(159,.133404,.44695),
//new TugCP(160,.22913,.500021),
//new TugCP(171,.376046,.452802),
//new RectVert(.706944,.519444,.892363,.309028),
//new MoveToMultiSelectPivotPoint(),
//new Move3d(Vec3f(.724869,.435967,0)),
//new Rotate(1,.879036,.819301),
//new TugCP(163,.604554,.523984),
//new TugCP(162,.474456,.540073),


new RectVert(-.3625,-.205556,.285416,-.636806),
new TugCP(18,.251997,-.410167),
new DragViewPos(-.014301,-.286434,0,.359722,-.608333),
new RectVert(-.4375,-.15,.4125,-.552084),
//new TugCP(115,.324812,-.314259),
//new Scale1d(1,-.037874,.289828),
//new Scale1d(1,-.037874,.094268),
//////////////


new TugCP(136,.339362,-.289643),

new Rotate(1,.016293,.168525),

new RectVert(-.498611,-.111111,.543056,-.315278),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.0155,-.332678,0)),
new Scale1d(1,.0155,.017465),


new RectVert(.684722,.491667,1.136806,-.260416),
new TugCP(306,.936677,-.032221),

new RectVert(.820833,.730556,1.197917,.436805),
new TugCP(309,1.071167,.67307),

new TugCP(6,.41916,-.581694),




new MouseZoom(4.11,-1,.869444),
new DragViewPos(-.013, -.346, 0, -1,.869444),

new TugCP(4,-.095911,-.635332),
new TugCP(5,.097941,-.635332),
//
//
//new RectVert(.293056,-.180556,.576389,-.438889),
//new TugCP(306,.497633,-.257184),
//new TugCP(307,.517252,-.167331),
//new TugCP(9,.475461,-.13192),
//new RectVert(.443056,.130556,.57639,-.042361),
//new TugCP(308,.525218,-.031027),
//new TugCP(6,.234642,-.547484),
//new TugCP(304,.461853,-.245504),
//new TugCP(306,.510133,-.232184),
//new TugCP(305,.492349,-.27101),

new Wait(5),



		//new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141227-Sketched-head-improved.smls"),
		//new Wait(5),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141227-Sketched-head-mirrored.smls"),

new Section("flat-face.wav"),
#if NARATION
	new DemoSound("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\naration\\flat-face.wav"),
#endif
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141228-Sketched-head-mirrored00.smls"),
		new Wait(1),
		new DragViewRot(0,1,0,1.5708),
		new Wait(.1),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\flat-face.smls"),
		new Wait(.1),
		new DragViewRot(0,1,0,0),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141228-Sketched-head-mirrored02.smls"),
		new Wait(1),

new Section("drag-lines-from-flat-face.wav"),
#if NARATION
	new DemoSound("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\naration\\drag-lines-from-flat-face.wav"),
#endif

		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141228-Sketched-head-mirrored07.smls"),
		new Wait(.1),
		new DragViewRot(.019342,.999805,-.003908,.905048),
		new Wait(1),
		new DragViewRot(0,1,0,0),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141228-Sketched-head-mirrored09.smls"),
		new Wait(1),
new DragViewRot(-.000003,.999993,.003616,.092455),
		new Wait(.2),
		new DragViewRot(0,1,0,0),
		new Wait(.1),

		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141228-Sketched-head-mirrored11.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141228-Sketched-head-mirrored.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\141229-Sketched-head-mirrored.smls"),
		new Wait(.2),
new DragViewRot(-.826341,.562724,-.02243,.066531),
		new Wait(.2),
		new DragViewRot(0,1,0,0),
		new Wait(.2),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\150103-Sketched-head-mirrored-white.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\Summer-2015-Vlog\\sketched-head\\model-list\\lines-removed.smls"),
		new Wait(.1),
new DragViewRot(.889322,.137183,.436219,.476535),
new Wait(.2),
new DragViewRot(-.003934,-.825881,.56383,.621219),
new Wait(.2),
new DragViewRot(.426975,.900353,.083999,.300136),
new Wait(.2),
		new DragViewRot(0,1,0,0),
		new Wait(1),
new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}

//new AddCtrlPnt(.418654,.522792),