/* Seamless3d

Copyright (C) 2001-2014 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

#define NARATION 1

extern const char* menu_open;

extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preShowArtDemo(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::showArtDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::showArtDemo(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		new Section("show-heads.wav"),

		//new ClickButton(fileMenu),
		//new Move_MenuItem(menu_open),
		//new Click,
		//new SetFieldValue("filename", "wallace-grom-char.smls"),
		//new ToggleField("open"),
		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\simple-head-shape-step-800.smls"),
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\show-heads.wav"),
#endif

#if NARATION
//	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\long-recording.wav"),
#endif

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\ultra-simple-head.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new ClickButton(setModellingMode),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140403-131123-art-head00.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new ClickButton(setHomeMode),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140403-131123-art-head02.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140403-131123-art-head03.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140403-131123-art-head04.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140403-131123-art-head06.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140403-131123-art-head.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140406-131123-art-head.smls"),
		new Wait(1),
		new ClickButton(setHomeMode),
		new DragViewRot(.319877, .928461, .188782, 1.259881,-1.178125,.971875),
		new DragViewRot(.938796,-.307464,.155329,.283948,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\female-head-bulbous-nose-long-nostrils.smls"),
		new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\female-head-grace-kelly-nose.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\130712-beautified-robot-surprise.smls"),
		new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\130711-beautified-robot-angry.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		//new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\130708-beautified-robot-smile.smls"),
		new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\130710-beautified-robot-smile.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),


		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140417-sarah_michelle_gellar_smile.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new Wait(.25),
		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\130708-beautified-robot.smls"),
		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\140417-sarah_michelle_gellar_smile-show-teeth.smls"),
		//new Wait(2),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\131127-art-head.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\robot-head.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-heads\\ultra-simple-head-g-with-moderate-complex-ears.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		

		//use to have 131123 here



	new Section("Sophie"),
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\sophie-3.wav"),
#endif

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\140410-art-head.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\140304-desmond-tutu.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-k.smls"),
		new Wait(5),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\sophie-close-up.smls"),
		
		new Wait(2),
		//new DragViewRot(0, 1, 0, -.15708, -1.178125,.971875),
		//new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		//new DragViewRot(-.018916,-.998112,-.058441,1.214819,-1.178125,.971875),
		//new DragViewRot(-.088883,.984841,.148954,1.25371,-1.178125,.971875),
		

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\white-sophie.smls"),
		new Wait(.25),
		new DragViewRot(-.018916,-.998112,-.058441,1.214819,-1.178125,.971875),
		new DragViewRot(-.088883,.984841,.148954,1.25371,-1.178125,.971875),
		//new DragViewRot(0, 1, 0, .15708,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\sophie-close-up.smls"),
		new Wait(1),

		new MouseZoom(1.175665,-1.178125,.971875),
		new DragViewPos(.01947,.856004,.048,-.903125,.31875),

		new DragViewRot(.090529,-.995126,-.039106,1.219549,-1.178125,.971875),
		new DragViewRot(.14005,-.988844,-.050725,3.812797,-1.178125,.971875),
		new DragViewRot(-.786274,-.40416,-.467363,5.808448,-1.178125,.971875),


		new DragViewRot(.090529,-.995126,-.039106,1.219549,-1.178125,.971875),
		new DragViewRot(.14005,-.988844,-.050725,3.812797,-1.178125,.971875),
		new DragViewRot(-.786274,-.40416,-.467363,5.808448,-1.178125,.971875),

		new DragViewRot(.090529,-.995126,-.039106,1.219549,-1.178125,.971875),
		new DragViewRot(.14005,-.988844,-.050725,3.812797,-1.178125,.971875),
		new DragViewRot(-.786274,-.40416,-.467363,5.808448,-1.178125,.971875),

		new Wait(.25),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\sophie-close-up.smls"),

		new Wait(.25),
		new DragViewRot(0, 1, 0, -.15708, -1.178125,.971875),
		new DragViewRot(.6771,.734785,.040345,.354079, -1.178125,.971875),
		new DragViewRot(.897092,.439422,.046203,2.467052, -1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new Wait(.25),


		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\080714_bezier_bikini_nurbs_girl.smls"),
		new Wait(1),
		new DragViewRot(0, 1, 0, -.53407,-1.178125,.971875),
		new Wait(1),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\080730_blue_bikini_girl.smls"),
		new Wait(2),
		new DragViewRot(0, -1, 0, -.53407,-1.178125,.971875),
		new Wait(1),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\080730_sophie-intermediate-with-zoe-hair.smls"),
		new Wait(1),
		new DragViewRot(0, 1, 0, -.53407,-1.178125,.971875),
		new Wait(1),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\zoe_blue_bikini.smls"),
		new Wait(1),
		new DragViewRot(0, -1, 0, -.53407,-1.178125,.971875),
		new Wait(1),


		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\sophie\\lucy-110328.smls"),
		new Wait(1),
		new DragViewRot(0, 1, 0, .15708,-1.178125,.971875),
		new Wait(1),
		//new Section("Lucy"),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-k.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-k-hairless.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-wide-nose.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-flat-wide-nose.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-flat-rounded-wide-nose.smls"),
		new Wait(1),

		new Wait(1),
		new DragViewRot(0, 1, 0, -PI*.5,-1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-non-prominant-chin.smls"),

		new Wait(1),
		new DragViewRot(0, 1, 0, .15708,-1.178125,.971875),

		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-almonder-eyes.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-rounder-nose-tip-short-nose.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-k-hawk-nose.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-heart-shape-face-mouth-wider-square-chin.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-heart-shape-face-mouth-wider-square-chin-cute-squash.smls"),

		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-thinner-more-defined-chin.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-heart-shape-face.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-heart-shape-face-mouth-wider.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-low-jaw.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-rounder-nose-tip.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-rounder-eyes.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-egyptian-eyes.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-sharper-eyes.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-sharper-eyes-opposite-angle.smls"),
		new Wait(1),


	new Section("Arthur"),
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\arthur.wav"),
#endif
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\Arthur.smls"),
		new Wait(2),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new Wait(5),

		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-k.smls"),
		//new Wait(2),
		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\Arthur.smls"),
		//new Wait(4),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140327-simplified-lucy.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140320-asmrn00b.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140226-4-year-old.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140225-giligan.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140227-ringo.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		//new Section("Temp"),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140228-micheal-cain.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new Wait(.25),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140417-micheal-cain-hybrid.smls"),
		new DragViewRot(0, 1, 0, -PI*.5, -1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140314-asian-head.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),


		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140224-sophie-asian-head-wide-eyes.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		
		//new Section("temp"),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140224-sophie-asian-head-wide-eyes.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140418-george-harrison-sophie-asian-head.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140419-george-harrison-sophie-asian-head02.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140419-george-harrison-sophie-asian-head03.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140419-george-harrison-sophie-asian-head04.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140419-george-harrison-sophie-asian-head.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),


		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140327-simplified-lucy.smls"),
		//new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		//new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		//new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140327-lucy-portrait.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),




		
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140415-art-head.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140320-art-head.smls"),
		//new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		//new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		//new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		//boring faces

		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\140129-simplified-lucy-cartoonised.smls"),
		//new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new DragViewRot(.335769,.941196,-.037531,1.255594, -1.178125,.971875),
		//new DragViewRot(-.558785,.778566,.285647,1.103834, -1.178125,.971875),
		//new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\ultra-simple-head-f.smls"),
		//new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new DragViewRot(.335769,.941196,-.037531,1.255594, -1.178125,.971875),
		//new DragViewRot(-.558785,.778566,.285647,1.103834, -1.178125,.971875),
		//new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140222-african-head.smls"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140408-african-head.smls"),
		new Wait(1),
		//new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		//new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		//new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		//new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140409-realistic-african-head.smls"),
		new Wait(.25),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),


		new Section("Valuble"),
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\valuble-3.wav"),
#endif




		//new Section("Ugly head with good nose"),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\valuable\\simple-head.smls"),
		new DragViewRot(.983957,.161999,-.074728,.556666, -1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(-.980855,.182013,.069245,.433285,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\valuable\\130519-simple-head.smls"),
		new DragViewRot(.983957,.161999,-.074728,.556666, -1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(-.980855,.182013,.069245,.433285,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\valuable\\130520-simple-head-with-ears.smls"),
		new DragViewRot(.983957,.161999,-.074728,.556666, -1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(-.980855,.182013,.069245,.433285,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),


		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\valuable\\140330-simple-head.smls"),
		new DragViewRot(.983957,.161999,-.074728,.556666, -1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(-.980855,.182013,.069245,.433285,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\valuable\\140401-simple-head.smls"),
		new DragViewRot(.983957,.161999,-.074728,.556666, -1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(-.980855,.182013,.069245,.433285,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
		
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140411-well-defined-jaw.smls"),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140412-well-defined-jaw.smls"),
		new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140413-well-defined-jaw.smls"),
		new Wait(2),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\arthur\\140414-well-defined-jaw.smls"),
		new Wait(2),
		new DragViewRot(-.987638,-.142628,.065024,.380464,-1.178125,.971875),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.925793,-.361832,-.109474,.532263,-1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),


//		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\valuable\\wallace-grom-char.smls"),
//new DragViewRot(.034848,-.999226,-.018239,1.273684),
//new DragViewRot(.88511,-.409348,-.221394,.092095),
//new DragViewRot(.233881,.969787,-.069375,.511686),
//new ClickButton(setModellingMode),
//new DragViewRot(.034848,-.999226,-.018239,1.273684),
//new DragViewRot(.88511,-.409348,-.221394,.092095),
//
//
//		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
//new DragViewRot(.494596,.848809,-.186809,.783502,-1.178125,.971875),
//new DragViewRot(-.812823,-.573554,-.101755,.966525,-1.178125,.971875),
//new ClickButton(setFrontViewOrientation),
//
//new ClickButton(setModellingMode),
//
//new ClickButton(toggleZBufferCageMode),
//
//new DragViewRot(-.012963,.999905,.004625,1.314427,-.540625,-.9875),


//new Section("Show rings"),
//new ClickButton(selectRing),
//#if NARATION
//	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\kikis-2-mouth-rings-b.wav"),
//#endif
//new SelNurbsLine(580,581,.087224),
//new TypeVirtKey('R'),
//new SelNurbsLine(534,535,.276952),
//
//
////new DragViewRot(-.010501,-.999641,.024641,1.484899, .090625,-.2375),
//new DragViewRot(0,-1,0,PI * .5, .090625,-.2375),
////new ClickButton(quantiseViewOrientation),
//new TypeVirtKey('R'),
//new SelNurbsLine(576,577,.298892),
//new DemoMove(-.2625,-.234375),
//new DemoMove(-.26875,-.146875),
//new DemoMove(-.2625,-.234375),
//new DemoMove(-.26875,-.146875),
//new DemoMove(-.2625,-.234375),
//new DemoMove(-.26875,-.146875),
//
//
//new DragViewRot(1,0,0,0,-.2625,-.234375),
//new TypeVirtKey('R'),
//new SelNurbsLine(542,543,.524955),
//new TugCP(541,.435885,-.319797),
//new DragViewRot(-.99908,-.034031,.026087,1.560444, .435885,-.319797),
//new TugCP(585,.453714,.019927),
//new DragViewRot(.642277,.607885,.466856,.050984, .453714,.019927),
//new TypeVirtKey('R'),
//new SelNurbsLine(583,584,.92704),
//
//new DemoMove(.384375,-.340625),
//new DemoMove(.478125,-.309375),
//new DemoMove(.375,-.25625),
//new TypeVirtKey('R'),
//new SelNurbsLine(538,539,.120847),
//new DemoMove(.478125,-.309375),
//new DemoMove(.384375,-.340625),




		new Section("About kiki"),
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\kiki2.wav"),
#endif

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\kiki\\white-kiki.smls"),
		new Wait(1),
new DragViewRot(-.982351,-.102141,.156699,.445475,-1.178125,.971875),
new ClickButton(toggleZBufferCageMode),

new DragViewRot(.17098,.964899,.19934,1.152082,-1.178125,.971875),
//new DragViewRot(.249448,.960709,.121713,3.220431),
//new DragViewRot(.18073,.565742,.804533,4.209661),
//new DragViewRot(-.322626,-.526335,.786692,4.390107),
new DragViewRot(-.702561,-.683363,-.19855,5.612056,-1.178125,.971875),
new ClickButton(setHomeMode),

//new Section("Show rings"),
//new DragViewRot(.198911,.96761,-.155453,5.687018),
new DragViewRot(-.16075,-.984659,-.067866,5.531854,-1.178125,.971875),
		new Wait(.25),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\kiki\\kiki-close-up.smls"),
		new Wait(.25),
new MouseZoom(1.771561,-1.178125,.971875),
new DragViewPos(.042577,-1.194158,-.067332,-.428125,-.434375),
new DragViewRot(-.177445,.978468,-.105418,5.283882,-.428125,-.434375),
new DragViewRot(-.062551,.996045,.063106,2.597044,-.428125,-.434375),
new DragViewRot(.120498,.9911,.056578,.64994,-.428125,-.434375),



		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\kiki\\show-only-mouth-structure-Kiki.smls"),
		new Wait(.25),
new ClickButton(selectRing),
new SelNurbsLine(580,581,.087224),
new TypeVirtKey('R'),
new SelNurbsLine(534,535,.276952),


//new DragViewRot(-.010501,-.999641,.024641,1.484899, .090625,-.2375),
new DragViewRot(0,-1,0,PI * .5, .078125,-.240625),
//new ClickButton(quantiseViewOrientation),
new TypeVirtKey('R'),
new SelNurbsLine(576,577,.298892),
new DemoMove(-.2625,-.234375),
new DemoMove(-.26875,-.146875),
new DemoMove(-.2625,-.234375),
new DemoMove(-.26875,-.146875),
new DemoMove(-.2625,-.234375),
new DemoMove(-.26875,-.146875),


new DragViewRot(1,0,0,0,-.2625,-.234375),
new TypeVirtKey('R'),
new SelNurbsLine(542,543,.524955),
new TugCP(541,.435885,-.319797),
new DragViewRot(-.99908,-.034031,.026087,1.560444, .435885,-.319797),
new TugCP(585,.453714,.019927),
new DragViewRot(.642277,.607885,.466856,.050984, .453714,.019927),
new TypeVirtKey('R'),
new SelNurbsLine(583,584,.92704),

new DemoMove(.384375,-.340625),
new DemoMove(.478125,-.309375),
new DemoMove(.375,-.25625),
new TypeVirtKey('R'),
new SelNurbsLine(538,539,.120847),
new DemoMove(.478125,-.309375),
new DemoMove(.384375,-.340625),



		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\kiki\\white-kiki-black-background.smls"),
		new Wait(1),
new DragViewRot(-.982351,-.102141,.156699,.445475,-1.178125,.971875),
new ClickButton(toggleZBufferCageMode),

//new DragViewRot(.17098,.964899,.19934,1.152082),
//new DragViewRot(-.982351,-.102141,.156699,.445475),
		new Wait(1),
		//new Section("end"),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\white-lucy-k.smls"),
		new Wait(1),
new DragViewPos(.000002,-1.65,.010001,-1.178125,.971875),
new DragViewRot(-.24881,-.936066,-.248744,1.320298,-1.178125,.971875),
new DragViewRot(.567232,-.657887,-.495412,1.114587,-1.178125,.971875),
new DragViewRot(-.013585,.998629,.050557,.875683,-1.178125,.971875),
//new DragViewRot(.808045,-.38976,-.441757,1.142181,-1.178125,.971875),
new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),
//new ClickButton(setModellingMode),
//new DragViewRot(-.3986,.87927,.260771,5.722794,-1.178125,.971875),
//new DragViewRot(-.22933,-.971424,-.061192,5.129982,-1.178125,.971875),
//new DragViewRot(-.454616, -.88958, -.044409, .325014,-1.178125,.971875),
new ClickButton(invertBackgroundColor),
new MouseZoom(8.140278,-1.178125,.971875),
new Wait(2),
new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-k-hairless.smls"),
new Wait(2),
new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\painted-lucy-k.smls"),
new Section("Complete"),
new Section("Aproching Kiki"),
new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\kiki\\more-complex-mouth.wav"),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\lucy-reduction-1st.smls"),
		new Wait(1),

new DragViewRot(.06677,-.995748,.063474,.756467),
new DragViewRot(-.900703,-.249611,.355568,.644912),
new ClickButton(setHomeMode),
new DragViewRot(-.296833,.881109,.368153,1.148653),
new DragViewRot(-.00575,.944131,.32952,1.858859),
new ClickButton(setModellingMode),
new DragViewRot(.801051,.594299,-.071598,.514425),
new DragViewRot(-.565273,-.81867,.101223,.50969),
new DragViewRot(.156979,-.966836,-.201458,1.642117),
new DragViewRot(.59361,-.416863,-.688369,2.059728),
new DragViewRot(.086795,-.944926,.315566,.462177),
new DragViewRot(.801051,.594299,-.071598,.514425),
new DragViewRot(-.565273,-.81867,.101223,.50969),
new DragViewRot(.156979,-.966836,-.201458,1.642117),
new DragViewRot(.59361,-.416863,-.688369,2.059728),

new DragViewRot(.59361,-.416863,-.688369,2.059728),
new DragViewRot(.086795,-.944926,.315566,.462177),
new DragViewRot(.801051,.594299,-.071598,.514425),
new DragViewRot(-.565273,-.81867,.101223,.50969),


new DragViewRot(.086795,-.944926,.315566,.462177),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\lucy-reduction-smooth-eyebrows-1st.smls"),
		new Wait(1),
new DragViewRot(.158625,.98052,-.115839,.833058),
new DragViewRot(.656246,-.740168,.146601,.523835),
new ClickButton(setHomeMode),
		new DragViewRot(0, -1, 0, -PI*.5,-1.178125,.971875),
		new DragViewPos(0,-1.65,.01,-1.178125,.971875),

		new Section("Lucy reduction"),

		//new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\lucy-reduction-smooth-eyebrows.smls"),
		//new Wait(2),

		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\white-cartoon-lucy-reduction-smooth-eyebrows.smls"),
		new Wait(1),
		new DragViewRot(0, -1, 0, -.53407,-1.178125,.971875),
		//new MouseZoom(8.140274,-1.178125,.971875),
		new Wait(1),


		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\cartoon-lucy-reduction-smooth-eyebrows.smls"),
		new Wait(1),
		new DragViewRot(0, 1, 0, -PI*.5,-1.178125,.971875),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\cartoon-lucy-reduction-smooth-eyebrows-b.smls"),
		new Wait(1),
		new DragViewRot(0, 1, 0, 0,-1.178125,.971875),
		new DragViewRot(0, 1, 0, -PI*.5,-1.178125,.971875),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\cartoon-lucy-reduction-smooth-eyebrows-c.smls"),
		new Wait(1),
		new DragViewRot(0, 1, 0, 0,-1.178125,.971875),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\cartoon-lucy-reduction-smooth-eyebrows-d.smls"),
		new Wait(1),
		new DragViewRot(0, -1, 0, -PI*.25,-1.178125,.971875),
		new DragViewRot(0, -1, 0, 0,-1.178125,.971875),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\cartoon-lucy-reduction-smooth-eyebrows-e.smls"),
		new Wait(1),
		new DragViewRot(0, -1, 0, -PI*.25,-1.178125,.971875),
		new DragViewRot(0, -1, 0, 0,-1.178125,.971875),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\cartoon-lucy-reduction-smooth-eyebrows-f.smls"),
		new Wait(1),
		new DragViewRot(0, -1, 0, -PI*.25,-1.178125,.971875),
		new DragViewRot(0, -1, 0, 0,-1.178125,.971875),
		new Wait(1),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\cartoon-lucy-reduction-smooth-eyebrows-g.smls"),
		new Wait(1),
		new DragViewRot(0, -1, 0, -PI*.25,-1.178125,.971875),
		new DragViewRot(0, -1, 0, 0,-1.178125,.971875),
		new Wait(1),
		new DragViewRot(0, -1, 0, -.53407,-1.178125,.971875),
		new Wait(1),


		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\thyme-upgrade-seamless-3-new-head.smls"),
		new DragViewRot(.057633,-.998272,.011441,1.298634,-1.178125,.971875),
		new DragViewRot(.335769,.941196,-.037531,1.255594, -1.178125,.971875),
		new DragViewRot(-.558785,.778566,.285647,1.103834, -1.178125,.971875),
		new DragViewRot(0, 1, 0, .15708, -1.178125,.971875),


		


new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
//new AddCtrlPnt(.418654,.522792),