#include <windows.h>
#include <direct.h>
#include <process.h>
#include <shlobj.h>

#include <sys/stat.h>
#include <share.h>
#include <fcntl.h>
#include <io.h>

#include <vector>
#include <map>
#include <algorithm>


#include <iostream>
#include <SDL/SDL.h>
#include <SDL/SDL_syswm.h>
#include <GL/glew.h>

#include <string>
#include <vector>

#include <initializer_list>
#include <iostream>
#include <fstream>
using namespace std;



#include "seamless3d.h"
#include "render-ogl.h"

#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"
#include "resource.h"
#include "input.h"


#include "seamless3d_gui_render.h"
#include "robot_aid.h"
#include "chat_window.h"

#ifdef WACOM_FILES
#include "WacomMultiTouch.h"
#include "WintabUtils.h"

#define PACKETDATA	(PK_X | PK_Y | PK_BUTTONS | PK_NORMAL_PRESSURE)
#define PACKETMODE	PK_BUTTONS
#include "pktdef.h"
#endif


#define ENGLISH 1
//#define FRENCH 1

#ifdef ENGLISH
#include "global_strings.h"
#elif FRENCH
#include "global_strings.fr.h"
#endif

#ifdef RECORD_SOUNDMOVIE
extern HANDLE g_hNotificationEvent;
#endif

#ifdef PROG_ROB
bool g_controlDown = false;
bool g_altDown = false;
bool g_shiftDown = false;
bool g_tabDown = false;
bool g_zKeyDown = false;
#endif
bool g_useWinTab = false;
Vec2i g_extraWinPix;
void outputScreenShotForDemo();
bool smlsIsSaved();
void saveBeforeClosing(void(*i_yesFunc)(FileCP& fileCP), void(*i_noFunc)(FileCP& fileCP), void(*i_cancelFunc)(FileCP& fileCP));
bool InitRender();
extern bool g_viewPosDragMode;
extern bool g_touchViewPosDragMode;
extern Vec3f g_touchBeginMousePos;
extern Vec3f g_touchBeginViewPos;
extern bool g_viewRotDragMode;
extern bool g_viewZRotDragMode;
extern Rotation g_beginViewRot;
extern Vec3f g_beginViewPos;
extern Vec2i g_beginMousePos;

bool g_winAPI3DMode = false;
void release3dDrag();
void release3dRightDrag();
void mouse2dSync();
void initPen();


extern HWND hWndMain;
extern HINSTANCE  g_hinst;

#define PI 3.14159265358979323846

Vec2i displaySize = Vec2i(1280, 720);
Matrix g_lookAtMat;

int textureWidth = 25 * 8 + 1;
int textureHeight = 25 + 1;


extern bool g_viewRotDragMode;
extern bool g_bReady;

int selectedButton = 0;

SDL_Window* sdlWindow = 0;
SDL_GLContext m_glContext;


Vec2i g_rightDragBegin;


Vec2i toolBarPos = Vec2i((displaySize.x / 2), (displaySize.y / 2) - textureHeight);
Vec2i toolBarPos2 = Vec2i((displaySize.x / 2), (displaySize.y / 2) + textureHeight * 2);


extern Rotation g_beginViewRot;
extern Vec2i g_mousePos;
extern Vec2i g_beginMousePos;


extern ScenePtr g_scene;
extern M_<SceneTreeListItem> g_sceneTreeList;
void postLoadProcessNodes(M_<SceneTreeListItem>& list);
void renderScene();
void hoverWin3d();
void addNodesForNewFile();
bool initWinINet();
void initRadialTug();
void openSceneTreeInterface();
Vec2i g_previousLeftClickPos;
void initializeShortCuts();
void makeTitleStr(char* str);

#ifdef WACOM_FILES

#define MAX_LOADSTRING 100

#include <memory>

typedef std::unique_ptr<WacomMTHitRect> WacomMTHitRectPtr;

// Global Variables:
std::map<int, WacomMTHitRectPtr>	g_lastWTHitRect;
std::map<int, WacomMTCapability>	g_caps;
std::vector<int>					g_devices;
extern HCTX g_tabCtx;

TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name



// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	MainWndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

bool										g_UseWinHitRect = true;
bool										g_ObserverMode = false;
RECT										g_clientRect = { 0, 0, 0, 0 };

enum EDataType
{
	ENoData,
	EFingerData,
	EBlobData,
	ERawData
}g_DataType = EFingerData;

CRITICAL_SECTION g_graphicsCriticalSection;

//////////////////////////////////////////////////////////////////////////////
// Purpose
//		Dump the MT capabilities of the specified device.
//
void DumpCaps(int deviceID)
{
	WacomTrace("MT Capabilities for deviceID: %i\n", deviceID);
	WacomTrace("\tVersion: %i\n", g_caps[deviceID].Version);
	WacomTrace("\tDeviceID: %i\n", g_caps[deviceID].DeviceID);
	WacomTrace("\tType: %i\n", (int)g_caps[deviceID].Type);
	WacomTrace("\tLogicalOriginX: %f\n", g_caps[deviceID].LogicalOriginX);
	WacomTrace("\tLogicalOriginY: %f\n", g_caps[deviceID].LogicalOriginY);
	WacomTrace("\tLogicalWidth: %f\n", g_caps[deviceID].LogicalWidth);
	WacomTrace("\tLogicalHeight: %f\n", g_caps[deviceID].LogicalHeight);
	WacomTrace("\tPhysicalSizeX: %f\n", g_caps[deviceID].PhysicalSizeX);
	WacomTrace("\tPhysicalSizeY: %f\n", g_caps[deviceID].PhysicalSizeY);
	WacomTrace("\tReportedSizeX: %i\n", g_caps[deviceID].ReportedSizeX);
	WacomTrace("\tReportedSizeY: %i\n", g_caps[deviceID].ReportedSizeY);
	WacomTrace("\tScanSizeX: %i\n", g_caps[deviceID].ScanSizeX);
	WacomTrace("\tScanSizeY: %i\n", g_caps[deviceID].ScanSizeY);
	WacomTrace("\tFingerMax: %i\n", g_caps[deviceID].FingerMax);
	WacomTrace("\tBlobMax: %i\n", g_caps[deviceID].BlobMax);
	WacomTrace("\tBlobPointsMax: %i\n", g_caps[deviceID].BlobPointsMax);
	WacomTrace("\tCapabilityFlags: 0x%X\n", g_caps[deviceID].CapabilityFlags);
}

///////////////////////////////////////////////////////////////////////////////
// Wintab support functions
//

///////////////////////////////////////////////////////////////////////////////
//  FUNCTION: InitWintabAPI()
//
//  PURPOSE: Initialize the Wintab pen API.
//
//  COMMENTS:
//		Loads the Wintab32 DLL and sets up the API function pointers.
//

///////////////////////////////////////////////////////////////////////////////
// Multi-touch API support functions.
WacomMTHitRectPtr GetAppHitRect();
int FingerCallback(WacomMTFingerCollection *fingerData, void *userData);
int BlobCallback(WacomMTBlobAggregate *blobData, void *userData);
int RawCallback(WacomMTRawData *rawData, void *userData);
void AttachCallback(WacomMTCapability deviceInfo, void *userRef);
void DetachCallback(int deviceID, void *userRef);
void DrawFingerData(int count, WacomMTFinger *fingers, int device);
void DrawBlobData(int count, WacomMTBlob *blobs, int device);
void DrawRawData(int count, unsigned short* rawBuf, int device);
void DumpCaps(int deviceID);
bool ClientHitRectChanged(const WacomMTHitRectPtr& wtHitRect_I, int deviceID);
WacomMTError RegisterForData(int deviceID);
WacomMTError MoveCallback(int deviceID);
WacomMTError UnregisterForData(int deviceID);


HCTX InitWintabAPI(HWND hwnd_I)
{
	if (!LoadWintab())
	{
		//ShowError("Wintab not available");
		return 0;
	}

	char TabletName[50] = "";
	gpWTInfoA(WTI_DEVICES, DVC_NAME, TabletName);
	gpWTInfoA(WTI_INTERFACE, IFC_WINTABID, TabletName);

	/* check if WinTab available. */
	if (!gpWTInfoA(0, 0, NULL))
	{
		ShowError("WinTab Services Not Available.");
		return FALSE;
	}

	/* get default region */
	LOGCONTEXTA logContext = { 0 };
	gpWTInfoA(WTI_DEFSYSCTX, 0, &logContext);

	// No need to specify lcInOrg* and lcInExt* as they are the entire
	// physical tablet area by default.

	// Get messages
	logContext.lcOptions |= CXO_MESSAGES;

	// Move the system cursor.
	logContext.lcOptions |= CXO_SYSTEM;

	logContext.lcPktData = PACKETDATA;
	logContext.lcPktMode = PACKETMODE;
	logContext.lcMoveMask = PACKETDATA;
	logContext.lcBtnUpMask = logContext.lcBtnDnMask;

	//// Guarantee the output coordinate space to be in screen coordinates.
	logContext.lcOutOrgX = GetSystemMetrics(SM_XVIRTUALSCREEN);
	logContext.lcOutOrgY = GetSystemMetrics(SM_YVIRTUALSCREEN);
	logContext.lcOutExtX = GetSystemMetrics(SM_CXVIRTUALSCREEN); //SM_CXSCREEN );

	// In Wintab, the tablet origin is lower left.  Move origin to upper left
	// so that it coincides with screen origin.
	logContext.lcOutExtY = -GetSystemMetrics(SM_CYVIRTUALSCREEN);	//SM_CYSCREEN );

	/* open the region */
	return gpWTOpenA(hwnd_I, (LPLOGCONTEXT)&logContext, TRUE);
}



WacomMTHitRectPtr GetAppHitRect()
{
	if (g_UseWinHitRect)
	{
		WINDOWINFO appWindowInfo = { 0 };
		appWindowInfo.cbSize = sizeof(appWindowInfo);
		GetWindowInfo(hWndMain, &appWindowInfo);

		WacomMTHitRect hitRect = {
			(float)appWindowInfo.rcClient.left,
			(float)appWindowInfo.rcClient.top,
			(float)(appWindowInfo.rcClient.right - appWindowInfo.rcClient.left),
			(float)(appWindowInfo.rcClient.bottom - appWindowInfo.rcClient.top)
		};

		return WacomMTHitRectPtr(new WacomMTHitRect(hitRect));
	}
	return WacomMTHitRectPtr();
}

WacomMTProcessingMode CurrentMode(void)
{
	return g_ObserverMode ? WMTProcessingModeObserver : WMTProcessingModeNone;
}


WacomMTError RegisterForData(int deviceID)
{
	WacomMTError res = WMTErrorInvalidParam;

	WacomMTHitRectPtr wtHitRect;
	if (g_caps[deviceID].Type == WMTDeviceTypeIntegrated)
	{
		wtHitRect = GetAppHitRect();
	}

	switch (g_DataType)
	{
	case EFingerData:
		res = WacomMTRegisterFingerReadHWND(deviceID, CurrentMode(), hWndMain, 5);
		break;
	}

	g_lastWTHitRect[deviceID] = std::move(wtHitRect);

	return res;
}


void AttachCallback(WacomMTCapability deviceInfo, void *userRef)
{
	if (!g_caps.count(deviceInfo.DeviceID))
	{
		g_devices.push_back(deviceInfo.DeviceID);
		g_caps[deviceInfo.DeviceID] = deviceInfo;
		WacomMTError res = RegisterForData(deviceInfo.DeviceID);
		if (res != WMTErrorSuccess)
		{
			return;
		}
	}
}

void DetachCallback(int deviceID, void *userRef)
{
	if (g_caps.count(deviceID))
	{
		UnregisterForData(deviceID);
		std::vector<int>::const_iterator iter = std::find(g_devices.begin(), g_devices.end(), deviceID);
		if (iter != g_devices.end())
		{
			g_devices.erase(iter);
		}
		g_caps.erase(deviceID);
	}
}


WacomMTError UnregisterForData(int deviceID) {
	WacomMTError res = WMTErrorInvalidParam;

	switch (g_DataType)
	{
	case EFingerData:
		res = WacomMTUnRegisterFingerReadHWND(hWndMain);
		break;

	}

	g_lastWTHitRect[deviceID].reset();

	return res;
}

enum Gesture {
	FREE = 0,
	MOVE_CURSOR = 1,
	ZOOM_VIEW = 2,
	PAN_VIEW = 3,
	ROTATE_VIEW = 4
};

int g_gestureMode = FREE;

M_Bool g_fingerDown = M_Bool(false, false, false, false);



bool allFingersAreUp() {
	for (int i = g_fingerDown.length; --i >= 0;) {
		if (g_fingerDown[i] == true) {
			return false;
		}
	}
	return true;
}


Vec2i g_panFirstFingerDownPos;




bool setMousePos(int id, int index, WacomMTFinger *fingers, int device) {
	if (fingers[index].FingerID == id && fingers[index].Confidence) {
		double x = fingers[index].X;
		double y = fingers[index].Y;
		if (g_caps[device].Type == WMTDeviceTypeOpaque) {
			// If we're using an opaque tablet, then the X and Y values are not in
			// pixels; they are a percentage of the tablet width (eg: 0.123, 0.37, etc.).
			// We need to convert to client pixels.
			x *= g_clientRect.right - g_clientRect.left;
			x += g_clientRect.left;
			y *= g_clientRect.bottom - g_clientRect.top;
			y += g_clientRect.top;
		}
		POINT pt = { (LONG)x, (LONG)y };
		ScreenToClient(hWndMain, &pt);
		g_newMousePos = Vec2i(pt.x, pt.y);
		return true;
	}
	return false;
}

Vec3f mouse2dSync(Vec2i pixelPos);

void interpretFingers(int fingerCount, WacomMTFinger *fingers, int device) {
	static String str;
	static float beginZoom = 1;

	if (g_devices.size() && fingerCount && fingers) {
		EnterCriticalSection(&g_graphicsCriticalSection);


		for (int index = 0; index < fingerCount; index++) {
			if (fingers[index].FingerID >= g_fingerDown.length) {
				continue;
			}

			if (fingers[index].TouchState == WMTFingerStateUp) {
				g_fingerDown[fingers[index].FingerID] = false;
				if (allFingersAreUp()) {
					g_gestureMode = FREE;
					if (g_winAPI3DMode) {
						release3dDrag();
					}
				}

				continue;
			}

			else if (g_gestureMode == MOVE_CURSOR) {
				continue;
			}
			if (g_gestureMode == ZOOM_VIEW) {
				if (setMousePos(1, index, fingers, device)) {
					float diff = g_newMousePos.y - g_beginMousePos.y;
					diff = diff * .002;

					if (diff > 0) {
						g_scene->setZoom(beginZoom * (1.0 + diff));
					}
					else {
						g_scene->setZoom(beginZoom / (1.0 - diff));
					}
					houseKeepVisualClue();
				}
				continue;
			}
			else if (g_gestureMode == PAN_VIEW) {
				setMousePos(2, index, fingers, device);
				g_touchViewPosDragMode = true;
				continue;
			}
			else if (g_gestureMode == ROTATE_VIEW) {
				setMousePos(3, index, fingers, device);
				continue;
			}


			if (g_gestureMode == FREE) {
				if (fingers[index].TouchState != WMTFingerStateNone) {

					if (fingers[index].FingerID == 0) {
						if (g_fingerDown[0] == false && fingers[index].TouchState == WMTFingerStateDown) {
							g_fingerDown[0] = true;
						}
					}
					if (fingers[index].FingerID == 1) {
						if (fingerCount == 2 && setMousePos(1, index, fingers, device)) {
							if (g_fingerDown[1] == false && fingers[index].TouchState == WMTFingerStateDown) {
								g_panFirstFingerDownPos = g_newMousePos;
								g_fingerDown[1] = true;
							}
							if (g_fingerDown[1]) {

								if (abs(g_newMousePos.y - g_panFirstFingerDownPos.y) > 3) {
									g_gestureMode = ZOOM_VIEW;
									g_beginMousePos = g_newMousePos;
									beginZoom = g_scene->getZoom();


									continue;

								}
							}
						}
					}
					else if (fingers[index].FingerID == 2) {
						// Skip this finger if NOT confident.
						if (fingerCount == 3 && setMousePos(2, index, fingers, device)) {

							if (g_fingerDown[2] == false && fingers[index].TouchState == WMTFingerStateDown) {
								g_panFirstFingerDownPos = g_newMousePos;
								g_fingerDown[2] = true;
								continue;
							}
							if (g_fingerDown[2]) {

								Vec2i diff = g_newMousePos - g_panFirstFingerDownPos;

								if (abs(diff.x) > 3 || abs(diff.y > 3)) {
									g_gestureMode = PAN_VIEW;
									Button::repeatCounter = 0;
									removeTypeFromList<Button>(g_callBackList);
									Window::removeToolTip();
									Window::removeMenu();

									g_prevMousePos = g_newMousePos;
									g_beginMousePos = g_newMousePos;
									g_touchBeginMousePos = mouse2dSync(g_newMousePos);
									g_touchBeginViewPos = g_scene->translation;

									g_winAPI3DMode = true;
									setMouseCapture();
									//Window::checkIfAWindowHasBeenMidClickedAndUpdate(g_newMousePos);
									//if(g_viewPosDragMode){
									g_touchViewPosDragMode = true;
									//}
									g_previousLeftClickPos = g_newMousePos;
								}
							}
						}
					}
					else if (fingers[index].FingerID == 3) {
						if (fingerCount == 4 && setMousePos(3, index, fingers, device)) {

							if (g_fingerDown[3] == false && fingers[index].TouchState == WMTFingerStateDown) {
								g_panFirstFingerDownPos = g_newMousePos;
								g_fingerDown[3] = true;
								continue;
							}
							if (g_fingerDown[3]) {


								Vec2i diff = g_newMousePos - g_panFirstFingerDownPos;

								if (abs(diff.x) > 3 || abs(diff.y > 3)) {
									g_gestureMode = ROTATE_VIEW;
									Button::repeatCounter = 0;
									removeTypeFromList<Button>(g_callBackList);
									Window::removeToolTip();
									Window::removeMenu();

									g_prevMousePos = g_newMousePos;

									g_winAPI3DMode = true;
									setMouseCapture();

									if ((controlKeyState()) || InputEvent::l_ctrlDown) {
										g_viewZRotDragMode = true;
									}
									else {
										g_viewRotDragMode = true;
									}

									g_beginMousePos = g_newMousePos;
									g_beginViewRot = g_scene->rotation;

									mouse2dSync();
								}
							}
						}
					}
				}
			}
		}
		LeaveCriticalSection(&g_graphicsCriticalSection);
	}
}


//end wacom functions////////////////////
#endif



extern Matrix projMatrix;


void setUpSDL(int width, int height, const std::string& title) {

	SDL_Init(SDL_INIT_EVERYTHING);

	SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 8);
	SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 8);
	SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 8);
	SDL_GL_SetAttribute(SDL_GL_ALPHA_SIZE, 8);
	SDL_GL_SetAttribute(SDL_GL_BUFFER_SIZE, 32);
	SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);

	sdlWindow = SDL_CreateWindow(title.c_str(), SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED, width, height, SDL_WINDOW_OPENGL);
	m_glContext = SDL_GL_CreateContext(sdlWindow);

	GLenum res = glewInit();
	if (res != GLEW_OK)
	{
		std::cerr << "Glew failed to initialize!" << std::endl;
	}

	glEnable(GL_DEPTH_TEST);

	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);
}

typedef  Rotation(Rotation::*RotationMultiplyRotationFP)(const Rotation&)const;

void getMemberAddresses();
void initVisualClue();

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

static bool g_leftMouseButtonDown = false;
static bool g_rightMouseButtonDown = false;

extern double g_previousClickTime;
extern double g_currentClickTime;
extern Vec3f g_beginViewPos;
extern bool g_dontCloseMenu;
extern Vec2i g_previousLeftClickPos;
extern bool g_winAPI3DMode;
void release3dDrag();
void release3dRightDrag();


void leftButtonDown(const Vec2i mousePos){
	Button::repeatCounter = 0;
	g_previousClickTime = g_currentClickTime;
	g_currentClickTime = g_time;

	Window::removeToolTip();

	g_mousePos = mousePos;
	g_prevMousePos = g_mousePos;
	g_beginMousePos = g_mousePos;
	g_newMousePos = g_mousePos;
	g_beginViewPos = g_scene->translation;

	//g_leftDoubleClicked = isDoubleLeftClick();
	//	dLog(String("g_leftDoubleClicked = " + String(g_leftDoubleClicked)));

	if (Button* button = Button::getHoverButton()) {

		DownButton::setDownButton(button);

		button->win.onClickButton();
		Window::activeWindow = &button->win;
		button->action();
		//button->win.paint();//do we need this?
		if (g_dontCloseMenu == false) {
			Window::removeMenu();
		}
	}
	else {
		//if(g_insertPatch.imousePhase == InsertPatch::LINE_MODE){
		//	g_insertPatch.imousePhase = InsertPatch::DIVERT_STANDBY;
		//	g_stw->cp->setupNodeWindow(g_insertComplete);
		//}
		//else if(g_deleteControlLine.mousePhase == 2){
		//	g_deleteControlLine.doLastPhase();
		//}
		//else{
		Window::removeMenu();
		Window::checkIfAWindowHasBeenClickedAndUpdate(g_mousePos);
		//}
	}


	g_dontCloseMenu = false;


	g_previousLeftClickPos = g_mousePos;

}
void rightButtonDown(const Vec2i mousePos) {
	Button::repeatCounter = 0;
	removeTypeFromList<Button>(g_callBackList);
	Window::removeToolTip();
	Window::removeMenu();

	g_mousePos = mousePos;
	g_prevMousePos = g_mousePos;
	g_newMousePos = g_mousePos;

	Window::checkIfAWindowHasBeenRightClickedAndUpdate(g_mousePos);
}

void leftButtonUp(const Vec2i mousePos) {
	g_mousePos = mousePos;

	if (g_drag) {
		g_drag->endDrag(g_mousePos);
	}
	else if (Button* button = DownButton::getDownButton()) {
		button->onButtonUp();
	}
	else {
		Window::activeWindow->release(g_mousePos);
	}
#ifdef PROG_ROB
	InputEvent::sceneTreeScrolPos = 0;
	if (g_upStr != "") {
		dLog(g_upStr);
	}
	g_upStr = "";

	InputEvent::sceneTreeScrolPos = g_stw->getScrollPosCollapsed();
#endif

	if (g_winAPI3DMode) {
		release3dDrag();
	}

}

void rightButtonUp(){
	if (g_winAPI3DMode){
		release3dRightDrag();
	}
}


extern BrushPtr g_brush;
void mouse2dSync();

void mouseMove(const Vec2i mousePos){
	//if(g_useWinTab && g_penEnabled){
	//	return TRUE;
	//}
	if (g_mergePatches.mousePhase != 0) {
		int a = 0;
	}
	int remOldMousePos = g_mousePos.y;
	if (g_mousePos == mousePos) {
		return;
	}

	if (g_scene->mode & PAINT_MODE) {
		if (g_scene->mode & BRUSH_MODE) {
			g_brush->houseKeep();
		}
	}

	g_mousePos = mousePos;
	g_newMousePos = g_mousePos;

	if (g_winAPI3DMode) {
		return;
	}

	//if(g_winAPI3DMode){
		//dLog("WM_MOUSEMOVE");
		//moveMouse3d();
		//break;
	//}

	Button* hoverButton = Button::getHoverButton();
	MultiSelect::resetDistance();
	//if(g_insertPatch.imousePhase == LINE_MODE){
	//	mouse2dSync(hWndMain);
	//	//g_insertPatch.mouseOverPatch->getRatioPhaseForInsert();
	//	g_insertPatch.addInsertVisualClue();
	//}
	if (g_insertPatch.imousePhase == InsertPatch::MONITOR_DIRECTION) {
		mouse2dSync();
		if (g_insertPatch.monitorDirection()) {
			g_insertPatch.m_insert_tempDivertBackup = g_insertPatch.m_insert;
			g_insertPatch.m_insertOD_tempDivertBackup = g_insertPatch.m_insertOD;
			g_insertPatch.remLeftSide_tempDivertBackup = g_insertPatch.remLeftSide;

			g_insertPatch.beginInsertIdx_tempDivertBackup = g_insertPatch.beginInsertIdx;
			g_insertPatch.beginInsertIdxOD_tempDivertBackup = g_insertPatch.beginInsertIdxOD;
			g_insertPatch.imousePhase = InsertPatch::DIVERT_STANDBY;
		}
		return;
	}
	if (g_insertPatch.imousePhase == InsertPatch::STANDBY || g_insertPatch.imousePhase == InsertPatch::LINE_MODE || g_insertPatch.imousePhase == InsertPatch::DIVERT_STANDBY || g_addBone->mousePhase != AddBone::NEUTRAL) {
		if (hoverButton) {
			hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos);
		}
		else {
			mouse2dSync();
			//SenseTugGlobals::initTug();
			if (NurbsPatch* patch = dynamic_cast<NurbsPatch*>(g_selNode.getRaw())) {
				Seamless* smls = patch->smls;
				if (g_insertPatch.imousePhase == InsertPatch::DIVERT_STANDBY) {
					if (smls->addDiversionMark()) {
						//g_insertPatch.imousePhase = InsertPatch::TEMP_DIVERT;
					}
				}
				else {
					smls->insertControlRowColum();
				}
			}
			else if (g_addBone->mousePhase != AddBone::NEUTRAL) {
				if (Art* part = dynamic_cast<Art*>(g_selNode.getRaw())) {
					mouse2dSync();
					g_addBone->initMouseOverLine(part->smls);
				}
			}
		}
	}
	if (g_mergePatches.mousePhase == MergePatches::STANDBY) {
		if (hoverButton) {
			hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos);
		}
		else {
			mouse2dSync();
			g_mergePatches.smls->mergePatchesStandby();
		}
	}
	if (g_deleteControlLine.mousePhase == 1 || g_deleteControlLine.mousePhase == 2) {
		if (hoverButton) {
			hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos);
		}
		else {
			mouse2dSync();
			if (g_scene->mode & ANIMATION_MODE) {
				if (Art* part = dynamic_cast<Art*>(g_selNode.getRaw())) {
					part->smls->deleteControlLine();
				}
			}
			else if (NurbsPatch* patch = dynamic_cast<NurbsPatch*>(g_selNode.getRaw())) {
				patch->smls->deleteControlLine();
			}
		}
	}
	else if (g_drag) {
		if (g_mousePos.x >= 0) {
			if (g_drag->triggered == false) {
				if (abs(g_mousePos.x - g_drag->beginMousePos.x) > 6 || abs(g_mousePos.y - g_drag->beginMousePos.y) > 6) {
					g_drag->triggered = true;
				}
			}
			if (g_drag->triggered) {
				g_drag->doDrag(g_mousePos);
				if (Window* window = dynamic_cast<Window*>(g_drag)) {
					window->shader->updatePosSize(window->pos, window->size);
				}

			}
		}
	}
	else if (hoverButton && hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos)) {
	}
	else {
		hoverWin3d();
	}
}

extern bool g_processComnandLine;
void openSmlsLastPhase(String fullFilePath, const bool recover = false);

const char* g_lpszCmdLine;
bool openFileFromCommandLine() {
	g_processComnandLine = false;
	if (strcmp(g_lpszCmdLine, "") != 0) {
		String file = g_lpszCmdLine;

		if (file[0] == '\"') {
			char longName[0x200];
			file = file.substring(1, file.length - 2);

			GetLongPathName(file.c_str(), longName, sizeof(longName));
			openSmlsLastPhase(longName);
		}
		else {
			openSmlsLastPhase(g_lpszCmdLine);
		}

		return true;
	}
	return false;
}


void convertVisualCluesToRenderFormat();
extern Ptr<Grid> g_grid;
extern HACCEL hAccel;
extern double	g_timeBegan;
void setupRecentFiles();
bool checkForLockFiles();

int main(int argc, char **argv) {

	g_lpszCmdLine = "";

	g_lookAtMat.m[3][2] = -3;

	getMemberAddresses();

	g_scene->rotation = Rotation(.831685, .555163, -.009739, .7695);

	try {
		mkdir(g_seamlessDir.c_str());
		mkdir(g_appDataDir.c_str());
		mkdir(g_undoDir.c_str());
		mkdir(g_screenshotDir.c_str());
		mkdir(g_demoDir.c_str());
		mkdir(g_demoCacheDir.c_str());

		SYSTEMTIME ToDaySystemTime;

		String debugStr = "\n\n\nSeamless3d ";
		debugStr += g_version;
#ifdef OPENGL
		debugStr += " OpenGL";
#endif
		dLog(debugStr);
		GetSystemTime(&ToDaySystemTime);
		char tmpChar[0x200];
		sprintf(tmpChar, "GMT: %.2i/%.2i/%i  %.2i:%.2i", ToDaySystemTime.wDay, ToDaySystemTime.wMonth, ToDaySystemTime.wYear, ToDaySystemTime.wHour, ToDaySystemTime.wMinute);
		dLog(tmpChar);

		//sprintf(tmpChar,"OS: - Version: %i.%i - build: %i ",_winmajor,_winminor,_osver);
		dLog(tmpChar);

		initializeShortCuts();

		initLookup();

		Settings::loadINI();
		g_mouseSense = 6.0 / g_settings->win3dSize.y;

		addNodesForNewFile();
		BackUp::createUniqueBackupName();

		Window::initializeWindows();
		initWinINet();

		// bumpy hack - recover auto-save file was inserted here

		initVisualClue();
		initRadialTug();



		//		createSting();

#ifdef WACOM_FILES
		InitializeCriticalSection(&g_graphicsCriticalSection);
#endif
		char TempStr[0x200];
		makeTitleStr(TempStr);






		setUpSDL(displaySize.x, displaySize.y, "OpenGL Color & 2D Texture");
		SDL_SysWMinfo wmInfo;
		SDL_VERSION(&wmInfo.version);
		SDL_GetWindowWMInfo(sdlWindow, &wmInfo);
		hWndMain = wmInfo.info.win.window;
		g_hinst = (HINSTANCE)GetWindowLong(hWndMain, GWL_HINSTANCE);


		///////
		initPen();
#ifdef WACOM_FILES
		WacomMTError res = WacomMTInitialize(WACOM_MULTI_TOUCH_API_VERSION);
		if (res == WMTErrorSuccess){
			int deviceCount = WacomMTGetAttachedDeviceIDs(NULL, 0);
			if (deviceCount){
				int newCount = 0;
				while (newCount != deviceCount){
					g_devices.resize(deviceCount, 0);
					newCount = WacomMTGetAttachedDeviceIDs(&g_devices[0], deviceCount * sizeof(int));
				}

				int loopCount = (int)g_devices.size();
				for (int idx = 0; idx < loopCount; idx++){
					WacomMTCapability cap = {0};
					res = WacomMTGetDeviceCapabilities(g_devices[idx], &cap);
					g_caps[g_devices[idx]] = cap;
					DumpCaps(g_devices[idx]);
				}
			}
			//following needed for finger touch
			res = WacomMTRegisterAttachCallback(AttachCallback, NULL);
			res = WacomMTRegisterDetachCallback(DetachCallback, NULL);

			int loopCount = (int)g_devices.size();
			for (int idx = 0; idx < loopCount; idx++)
			{
				res = RegisterForData(g_devices[idx]);
			}
		}

#endif
		getClientRect(clientOffest);
		g_3d->size = Vec2i(clientOffest.right - clientOffest.left, clientOffest.bottom - clientOffest.top);
		ToolBarWin::initToolbar();
		g_acp->initialize();
		g_stw = new SceneTree;
		g_rcp = new ControlPanel;
		//g_acp = new AnimControlPanel;
		openSceneTreeInterface();



///////////
		g_scene->genNodeList2();
		postLoadProcessNodes(g_sceneTreeList);


//		convertVisualCluesToRenderFormat();



		g_arrowCursor = (long)LoadCursor(0, MAKEINTRESOURCE(IDC_ARROW));
		g_handCursor = (long)LoadCursor(0, MAKEINTRESOURCE(IDC_HAND));

		g_sizeAllCursor = (long)LoadCursor(0, MAKEINTRESOURCE(IDC_SIZEALL));
		g_sizeNWSECursor = (long)LoadCursor(0, MAKEINTRESOURCE(IDC_SIZENWSE));
		g_sizeNESWCursor = (long)LoadCursor(0, MAKEINTRESOURCE(IDC_SIZENESW));
		g_sizeWECursor = (long)LoadCursor(0, MAKEINTRESOURCE(IDC_SIZEWE));
		g_sizeNSCursor = (long)LoadCursor(0, MAKEINTRESOURCE(IDC_SIZENS));

		g_currentType2 = g_arrowCursor;


		g_crossCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(CROSS_CURSOR));
		g_lockedOnPointCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(LOCKED_ON_POINT_CURSOR));
		g_addPointCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(ADD_POINT_CURSOR));
		g_insertLineCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(INSERT_LINE_CURSOR));
		g_deleteLineCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(DELETE_LINE_CURSOR));
		g_mergePatchesCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(MERGE_PATCHES_CURSOR));
		g_addGeometryCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(ADD_GEOMETRY_CURSOR));
		g_addGeometryMirrorCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(ADD_GEOMETRY_MIRROR_CURSOR));
		g_ringSelectCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(RING_SELECT_CURSOR));
		g_rectangleSelectPointCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(RECTANGLE_SELECT_POINT_CURSOR));
		g_rectangleUnselectCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(RECTANGLE_UNSELECT_CURSOR));
		g_rectangleSelectPolyCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(RECTANGLE_SELECT_POLY_CURSOR));
		g_fillCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(FILL_CURSOR));
		g_brushCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(BRUSH_CURSOR));
		g_eyeDropperCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(COLOR_PICKER_CURSOR));
		g_knifeCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(CUT_PATCH_CURSOR));
		g_addBoneCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(ADD_BONE_CURSOR));
		g_insertBoneCursor = (long)LoadCursor(g_hinst, MAKEINTRESOURCE(INSERT_BONE_CURSOR));

		g_modellingCursor = g_crossCursor;



		resetLooseEnds();
		Viewpoint::gotoFirstViewpoint();
		//g_grid->houseKeep();

		Window::topWindow = g_tb.p;
		Window::topWindow = g_tb2.p;


		g_stw->size = Vec2i(330, 660);
		g_stw->pos = Vec2i(g_3d->size.x - 330, 0);
		g_stw->newNodeBar.dstPos = Vec2i(g_stw->size.x - 80, 30);
		g_stw->cp->size = Vec2i(350, g_stw->cp->size.y);
		g_stw->cp->pos = Vec2i(0, 26);
		Window::postLoadProcessWin(*g_scene);
		//if(g_tb->pos.y > g_3d->size.y - g_tb->size.y){
		//	g_tb->pos = Vec2i(0, g_3d->size.y - g_tb->size.y);
		//}

		g_tb->pos = Vec2i(0, 0);
		g_tb2->pos = Vec2i(0, g_3d->size.y - 25);

		Window::activeWindow = g_tb.p;
		Window::activeWindow = g_tb2.p;

		// Load keyboard accelerators
		hAccel = LoadAccelerators(g_hinst, MAKEINTRESOURCE(IDR_MAIN_ACCEL));

#ifdef FRAME_TIME_SYNC
		g_timeBegan = g_time = 0;
#else
		g_timeBegan = g_time = timeGetTime() * MILISECONDS_TO_SECONDS;
#endif

		// Enter the message loop
		MSG msg;
		ZeroMemory(&msg, sizeof(msg));

		//if(g_createdINI){
		//}
		BOOL bGotMsg = FALSE;
		g_stw->size = Vec2i(g_stw->size.x, g_stw->size.y); //do we really need this?
		g_stw->paint();

		if (checkForLockFiles() == false) {
			if (openFileFromCommandLine() == false) {
				setupRecentFiles();
			}
		}



		SDL_Event e;
		bool isRunning = true;
		float counter = 0.0f;


		g_bReady = true;
		g_scene->mode.refValue() ^= BACKFACE_IGNORE_MODE;

		setModellingMode();

		g_scene->updateBuild();

		while (isRunning)
		{
			while (SDL_PollEvent(&e)) {
				if (e.type == SDL_MOUSEWHEEL) {

					Window::activeOnMouseWheel(e.wheel.y);

					//e.wheel.x is for scroll left or right which most mice dont have

				}
				if (e.type == SDL_QUIT)
					isRunning = false;
			}

			glClearColor(.5, .5, .5, 1);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

			float aspect = (float)displaySize.x / (float)displaySize.y;
			float left = -aspect;
			float right = aspect;
			float bottom = -1;
			float top = 1;
			float zNear = -3;
			float zFar = 100;

			projMatrix.m[0][0] = 2.0f / (right - left);
			projMatrix.m[1][1] = 2.0f / (top - bottom);
			projMatrix.m[2][2] = -2.0f / (zFar - zNear);
			projMatrix.m[3][0] = -(right + left) / (right - left);
			projMatrix.m[3][1] = -(top + bottom) / (top - bottom);
			projMatrix.m[3][2] = -(zFar + zNear) / (zFar - zNear);

			glEnable(GL_DEPTH_TEST);
			renderScene();
			glDisable(GL_DEPTH_TEST);


			SDL_PumpEvents();
			Vec2i mousePos;
			unsigned int mouseState = SDL_GetMouseState(&mousePos.x, &mousePos.y);

			if (g_leftMouseButtonDown) {
				if (false == (mouseState & SDL_BUTTON(SDL_BUTTON_LEFT))) {
					g_leftMouseButtonDown = false;

					leftButtonUp(mousePos);
				}
			}
			else {
				if (mouseState & SDL_BUTTON(SDL_BUTTON_LEFT)) {
					g_leftMouseButtonDown = true;

					leftButtonDown(mousePos);
				}
			}
			if (g_rightMouseButtonDown) {
				if (false == (mouseState & SDL_BUTTON(SDL_BUTTON_RIGHT))) {
					g_rightMouseButtonDown = false;
					rightButtonUp();
				}
			}
			else {
				if (mouseState & SDL_BUTTON(SDL_BUTTON_RIGHT)) {
					g_rightMouseButtonDown = true;
					rightButtonDown(mousePos);
					/*
					if (g_viewRotDragMode == false) {
						g_viewRotDragMode = true;
						g_beginMousePos = g_mousePos = g_mousePos = mousePos;
						g_rightDragBegin = mousePos;
						g_beginViewRot = g_scene->rotation;
					}
					*/
				}
			}
			//		else if (g_viewRotDragMode) {
			//			g_viewRotDragMode = false;
			//		}

			if (mousePos != g_mousePos) {//mouse move
				mouseMove(mousePos);
			}

			Window::renderVisible();
			for (int i = 0; i < g_callBackList.length; i++) {
				g_callBackList[i]->doCallBack();
			}


			SDL_GL_SwapWindow(sdlWindow);
			SDL_Delay(1);
		}

		//cnc->deleteProgram();
		//cnt->deleteProgram();

		SDL_GL_DeleteContext(m_glContext);
		SDL_DestroyWindow(sdlWindow);
		SDL_Quit();
	}
	catch (Field*e) {
		dLog("error in " + e->getTypeStr());
	}
	catch (M_Float* e) {
		dLog("error in M_Float");
		dLog((int)e);
		dLog((char *)e->showReason());
	}
	catch (M_Vec3f* e) {
		dLog("error in M_Vec3f");
		dLog((int)e);
		dLog((char *)e->showReason());
	}
	catch (M_Vec2f* e) {
		dLog("error in M_Vec2f");
		dLog((char *)e->showReason());
	}
	catch (String* e) {
		dLog("error in String");
		dLog((char *)e->showReason());
	}
	catch (M_Color3f* e) {
		dLog("error in M_Color3f");
		dLog((char *)e->showReason());
	}
	catch (M_Int* e) {
		dLog("error in M_Int");
		dLog((char *)e->showReason());
	}
	catch (M_Node* e) {
		dLog("error in M_Node");
		dLog((char *)e->showReason());
	}

	catch (M_Triangle* e) {
		dLog("error in M_Triangle");
		dLog((int)e);
		dLog((char *)e->showReason());
	}

	catch (Node* e) {
		dLog(String("Exception in ") + e->getTypeStr());
	}
	catch (...) {
		dLog(String("Exception ..."));
	}

	InputEvent::resumeSequence();
	return 0;
}


